## kernel-image-2.4.18-hppa 62.4

=== linux/Makefile ===
VERSION = 2
PATCHLEVEL = 4
SUBLEVEL = 18
EXTRAVERSION =

KERNELRELEASE=$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
KERNELPATH=kernel-$(shell echo $(KERNELRELEASE) | sed -e "s/-//g")

ARCH := parisc

UTS_MACHINE := $(ARCH)

CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo bash; fi ; fi)
SHELL := $(CONFIG_SHELL)
TOPDIR	:= $(shell /bin/pwd)

HPATH   	= $(TOPDIR)/include
FINDHPATH	= $(HPATH)/asm $(HPATH)/linux $(HPATH)/scsi $(HPATH)/net

HOSTCC  	= gcc
HOSTCFLAGS	= -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer

CROSS_COMPILE 	=

#
# Include the make variables (CC, etc...)
#

AS		= $(CROSS_COMPILE)as
LD		= $(CROSS_COMPILE)ld
CC		= $(CROSS_COMPILE)gcc-3.0
#===== NOTE =====
#  egcs-2.91.66 is the recommended compiler version for building XFS.
#  Most of the XFS developers are using that particular version for
#  development, testing, and performance analysis work, and it will
#  generate a functional XFS kernel (some versions of gcc will not) -
#  uncomment the following line to force that gcc version to be used:
#CC		= $(CROSS_COMPILE)gcc -V egcs-2.91.66
#  On early versions of RedHat 7.x, kgcc is the recommended compiler
#  for building the kernel (kgcc is the same as egcs-2.91.66) - if
#  you use such a distribution and wish to use kgcc, uncomment this:
#CC		= $(CROSS_COMPILE)kgcc 
#  The default gcc with RedHat 7.1 (gcc-2.96-81) also appears to
#  generate good code, earlier versions of 2.96 are however an
#  unknown quantity and not recommended.
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
MAKEFILES	= $(TOPDIR)/.config
GENKSYMS	= /sbin/genksyms
DEPMOD		= /bin/true
MODFLAGS	= -DMODULE
CFLAGS_KERNEL	=
PERL		= perl

export	VERSION PATCHLEVEL SUBLEVEL EXTRAVERSION KERNELRELEASE ARCH \
	CONFIG_SHELL TOPDIR HPATH HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC \
	CPP AR NM STRIP OBJCOPY OBJDUMP MAKE MAKEFILES GENKSYMS MODFLAGS PERL

all:	do-it-all

#
# Make "config" the default target if there is no configuration file or
# "depend" the target if there is no top-level dependency information.
#

ifeq (.config,$(wildcard .config))
include .config
ifeq (.depend,$(wildcard .depend))
include .depend
do-it-all:	Version vmlinux
else
CONFIGURATION = depend
do-it-all:	depend
endif
else
CONFIGURATION = config
do-it-all:	config
endif

#
# INSTALL_PATH specifies where to place the updated kernel and system map
# images.  Uncomment if you want to place them anywhere other than root.
#

#export	INSTALL_PATH=/boot

#
# INSTALL_MOD_PATH specifies a prefix to MODLIB for module directory
# relocations required by build roots.  This is not defined in the
# makefile but the arguement can be passed to make if needed.
#

MODLIB	:= $(INSTALL_MOD_PATH)/lib/modules/$(KERNELRELEASE)
export MODLIB

#
# standard CFLAGS
#

CPPFLAGS := -D__KERNEL__ -I$(HPATH)

CFLAGS := $(CPPFLAGS) -Wall -Wstrict-prototypes -Wno-trigraphs -O2 \
	  -fomit-frame-pointer -fno-strict-aliasing -fno-common
AFLAGS := -D__ASSEMBLY__ $(CPPFLAGS)

#
# ROOT_DEV specifies the default root-device when making the image.
# This can be either FLOPPY, CURRENT, /dev/xxxx or empty, in which case
# the default of FLOPPY is used by 'build'.
# This is i386 specific.
#

export ROOT_DEV = CURRENT

#
# If you want to preset the SVGA mode, uncomment the next line and
# set SVGA_MODE to whatever number you want.
# Set it to -DSVGA_MODE=NORMAL_VGA if you just want the EGA/VGA mode.
# The number is the same as you would ordinarily press at bootup.
# This is i386 specific.
#

export SVGA_MODE = -DSVGA_MODE=NORMAL_VGA

#
# If you want the RAM disk device, define this to be the size in blocks.
# This is i386 specific.
#

#export RAMDISK = -DRAMDISK=512

CORE_FILES	=kernel/kernel.o mm/mm.o fs/fs.o ipc/ipc.o
NETWORKS	=net/network.o

LIBS		=$(TOPDIR)/lib/lib.a
SUBDIRS		=kernel drivers mm fs net ipc lib

DRIVERS-n :=
DRIVERS-y :=
DRIVERS-m :=
DRIVERS-  :=

DRIVERS-$(CONFIG_ACPI) += drivers/acpi/acpi.o
DRIVERS-$(CONFIG_PARPORT) += drivers/parport/driver.o
DRIVERS-y += drivers/char/char.o \
	drivers/block/block.o \
	drivers/misc/misc.o \
	drivers/net/net.o \
	drivers/media/media.o
DRIVERS-$(CONFIG_AGP) += drivers/char/agp/agp.o
DRIVERS-$(CONFIG_DRM_NEW) += drivers/char/drm/drm.o
DRIVERS-$(CONFIG_DRM_OLD) += drivers/char/drm-4.0/drm.o
DRIVERS-$(CONFIG_NUBUS) += drivers/nubus/nubus.a
DRIVERS-$(CONFIG_ISDN) += drivers/isdn/isdn.a
DRIVERS-$(CONFIG_NET_FC) += drivers/net/fc/fc.o
DRIVERS-$(CONFIG_APPLETALK) += drivers/net/appletalk/appletalk.o
DRIVERS-$(CONFIG_TR) += drivers/net/tokenring/tr.o
DRIVERS-$(CONFIG_WAN) += drivers/net/wan/wan.o
DRIVERS-$(CONFIG_ARCNET) += drivers/net/arcnet/arcnetdrv.o
DRIVERS-$(CONFIG_ATM) += drivers/atm/atm.o
DRIVERS-$(CONFIG_IDE) += drivers/ide/idedriver.o
DRIVERS-$(CONFIG_FC4) += drivers/fc4/fc4.a
DRIVERS-$(CONFIG_SCSI) += drivers/scsi/scsidrv.o
DRIVERS-$(CONFIG_FUSION_BOOT) += drivers/message/fusion/fusion.o
DRIVERS-$(CONFIG_IEEE1394) += drivers/ieee1394/ieee1394drv.o

ifneq ($(CONFIG_CD_NO_IDESCSI)$(CONFIG_BLK_DEV_IDECD)$(CONFIG_BLK_DEV_SR)$(CONFIG_PARIDE_PCD),)
DRIVERS-y += drivers/cdrom/driver.o
endif

DRIVERS-$(CONFIG_SOUND) += drivers/sound/sounddrivers.o
DRIVERS-$(CONFIG_PCI) += drivers/pci/driver.o
DRIVERS-$(CONFIG_MTD) += drivers/mtd/mtdlink.o
DRIVERS-$(CONFIG_PCMCIA) += drivers/pcmcia/pcmcia.o
DRIVERS-$(CONFIG_NET_PCMCIA) += drivers/net/pcmcia/pcmcia_net.o
DRIVERS-$(CONFIG_NET_WIRELESS) += drivers/net/wireless/wireless_net.o
DRIVERS-$(CONFIG_PCMCIA_CHRDEV) += drivers/char/pcmcia/pcmcia_char.o
DRIVERS-$(CONFIG_DIO) += drivers/dio/dio.a
DRIVERS-$(CONFIG_SBUS) += drivers/sbus/sbus_all.o
DRIVERS-$(CONFIG_ZORRO) += drivers/zorro/driver.o
DRIVERS-$(CONFIG_FC4) += drivers/fc4/fc4.a
DRIVERS-$(CONFIG_ALL_PPC) += drivers/macintosh/macintosh.o
DRIVERS-$(CONFIG_MAC) += drivers/macintosh/macintosh.o
DRIVERS-$(CONFIG_ISAPNP) += drivers/pnp/pnp.o
DRIVERS-$(CONFIG_SGI_IP22) += drivers/sgi/sgi.a
DRIVERS-$(CONFIG_VT) += drivers/video/video.o
DRIVERS-$(CONFIG_PARIDE) += drivers/block/paride/paride.a
DRIVERS-$(CONFIG_HAMRADIO) += drivers/net/hamradio/hamradio.o
DRIVERS-$(CONFIG_TC) += drivers/tc/tc.a
DRIVERS-$(CONFIG_USB) += drivers/usb/usbdrv.o
DRIVERS-$(CONFIG_INPUT) += drivers/input/inputdrv.o
DRIVERS-$(CONFIG_HIL) += drivers/hil/hil.o
DRIVERS-$(CONFIG_I2O) += drivers/message/i2o/i2o.o
DRIVERS-$(CONFIG_IRDA) += drivers/net/irda/irda.o
DRIVERS-$(CONFIG_I2C) += drivers/i2c/i2c.o
DRIVERS-$(CONFIG_PHONE) += drivers/telephony/telephony.o
DRIVERS-$(CONFIG_MD) += drivers/md/mddev.o
DRIVERS-$(CONFIG_GSC) += drivers/gsc/gscbus.o
DRIVERS-$(CONFIG_BLUEZ) += drivers/bluetooth/bluetooth.o
DRIVERS-$(CONFIG_HOTPLUG_PCI) += drivers/hotplug/vmlinux-obj.o

DRIVERS := $(DRIVERS-y)


# files removed with 'make clean'
CLEAN_FILES = \
	kernel/ksyms.lst include/linux/compile.h \
	vmlinux System.map \
	.tmp* \
	drivers/char/consolemap_deftbl.c drivers/video/promcon_tbl.c \
	drivers/char/conmakehash \
	drivers/char/drm/*-mod.c \
	drivers/pci/devlist.h drivers/pci/classlist.h drivers/pci/gen-devlist \
	drivers/zorro/devlist.h drivers/zorro/gen-devlist \
	drivers/sound/bin2hex drivers/sound/hex2hex \
	drivers/atm/fore200e_mkfirm drivers/atm/{pca,sba}*{.bin,.bin1,.bin2} \
	drivers/scsi/aic7xxx/aicasm/aicasm_gram.c \
	drivers/scsi/aic7xxx/aicasm/aicasm_scan.c \
	drivers/scsi/aic7xxx/aicasm/y.tab.h \
	drivers/scsi/aic7xxx/aicasm/aicasm \
	drivers/scsi/53c700_d.h \
	net/khttpd/make_times_h \
	net/khttpd/times.h \
	submenu*
# directories removed with 'make clean'
CLEAN_DIRS = \
	modules

# files removed with 'make mrproper'
MRPROPER_FILES = \
	include/linux/autoconf.h include/linux/version.h \
	drivers/net/hamradio/soundmodem/sm_tbl_{afsk1200,afsk2666,fsk9600}.h \
	drivers/net/hamradio/soundmodem/sm_tbl_{hapn4800,psk4800}.h \
	drivers/net/hamradio/soundmodem/sm_tbl_{afsk2400_7,afsk2400_8}.h \
	drivers/net/hamradio/soundmodem/gentbl \
	drivers/sound/*_boot.h drivers/sound/.*.boot \
	drivers/sound/msndinit.c \
	drivers/sound/msndperm.c \
	drivers/sound/pndsperm.c \
	drivers/sound/pndspini.c \
	drivers/atm/fore200e_*_fw.c drivers/atm/.fore200e_*.fw \
	.version .config* config.in config.old \
	scripts/tkparse scripts/kconfig.tk scripts/kconfig.tmp \
	scripts/lxdialog/*.o scripts/lxdialog/lxdialog \
	.menuconfig.log \
	include/asm \
	.hdepend scripts/mkdep scripts/split-include scripts/docproc \
	$(TOPDIR)/include/linux/modversions.h \
	kernel.spec

# directories removed with 'make mrproper'
MRPROPER_DIRS = \
	include/config \
	$(TOPDIR)/include/linux/modules


include arch/$(ARCH)/Makefile

export	CPPFLAGS CFLAGS CFLAGS_KERNEL AFLAGS AFLAGS_KERNEL

kbuild_2_4_nostdinc     := -nostdinc $(shell $(CC) -print-search-dirs | sed -ne 's/install: \(.*\)/-I \1include/gp')
export kbuild_2_4_nostdinc

export	CPPFLAGS CFLAGS AFLAGS

export	NETWORKS DRIVERS LIBS HEAD LDFLAGS LINKFLAGS MAKEBOOT ASFLAGS

.S.s:
	$(CPP) $(AFLAGS) $(AFLAGS_KERNEL) -traditional -o $*.s $<
.S.o:
	$(CC) $(AFLAGS) $(AFLAGS_KERNEL) -traditional -c -o $*.o $<

Version: dummy
	@rm -f include/linux/compile.h

boot: vmlinux
	@$(MAKE) CFLAGS="$(CFLAGS) $(CFLAGS_KERNEL)" -C arch/$(ARCH)/boot

vmlinux: include/linux/version.h $(CONFIGURATION) init/main.o init/version.o linuxsubdirs
	$(LD) $(LINKFLAGS) $(HEAD) init/main.o init/version.o \
		--start-group \
		$(CORE_FILES) \
		$(DRIVERS) \
		$(NETWORKS) \
		$(LIBS) \
		--end-group \
		-o vmlinux
	$(NM) vmlinux | grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | sort > System.map

symlinks:
	rm -f include/asm
	( cd include ; ln -sf asm-$(ARCH) asm)
	@if [ ! -d include/linux/modules ]; then \
		mkdir include/linux/modules; \
	fi

oldconfig: symlinks
	$(CONFIG_SHELL) scripts/Configure -d arch/$(ARCH)/config.in

xconfig: symlinks
	$(MAKE) -C scripts kconfig.tk
	wish -f scripts/kconfig.tk

menuconfig: include/linux/version.h symlinks
	$(MAKE) -C scripts/lxdialog all
	$(CONFIG_SHELL) scripts/Menuconfig arch/$(ARCH)/config.in

config: symlinks
	$(CONFIG_SHELL) scripts/Configure arch/$(ARCH)/config.in

include/config/MARKER: scripts/split-include include/linux/autoconf.h
	scripts/split-include include/linux/autoconf.h include/config
	@ touch include/config/MARKER

linuxsubdirs: $(patsubst %, _dir_%, $(SUBDIRS))

$(patsubst %, _dir_%, $(SUBDIRS)) : dummy include/linux/version.h include/config/MARKER
	$(MAKE) CFLAGS="$(CFLAGS) $(CFLAGS_KERNEL)" -C $(patsubst _dir_%, %, $@)

$(TOPDIR)/include/linux/version.h: include/linux/version.h
$(TOPDIR)/include/linux/compile.h: include/linux/compile.h

newversion:
	. scripts/mkversion > .tmpversion
	@mv -f .tmpversion .version

include/linux/compile.h: $(CONFIGURATION) include/linux/version.h newversion
	@echo -n \#define UTS_VERSION \"\#`cat .version` > .ver
	@if [ -n "$(CONFIG_SMP)" ] ; then echo -n " SMP" >> .ver; fi
	@if [ -f .name ]; then  echo -n \-`cat .name` >> .ver; fi
	@echo ' '`date`'"' >> .ver
	@echo \#define LINUX_COMPILE_TIME \"`date +%T`\" >> .ver
	@echo \#define LINUX_COMPILE_BY \"`whoami`\" >> .ver
	@echo \#define LINUX_COMPILE_HOST \"`hostname`\" >> .ver
	@if [ -x /bin/dnsdomainname ]; then \
	   echo \#define LINUX_COMPILE_DOMAIN \"`dnsdomainname`\"; \
	 elif [ -x /bin/domainname ]; then \
	   echo \#define LINUX_COMPILE_DOMAIN \"`domainname`\"; \
	 else \
	   echo \#define LINUX_COMPILE_DOMAIN ; \
	 fi >> .ver
	@echo \#define LINUX_COMPILER \"`$(CC) $(CFLAGS) -v 2>&1 | tail -1`\" >> .ver
	@mv -f .ver $@

include/linux/version.h: ./Makefile
	@echo \#define UTS_RELEASE \"$(KERNELRELEASE)\" > .ver
	@echo \#define LINUX_VERSION_CODE `expr $(VERSION) \\* 65536 + $(PATCHLEVEL) \\* 256 + $(SUBLEVEL)` >> .ver
	@echo '#define KERNEL_VERSION(a,b,c) (((a) << 16) + ((b) << 8) + (c))' >>.ver
	@mv -f .ver $@

comma	:= ,

init/version.o: init/version.c include/linux/compile.h include/config/MARKER

=== linux/drivers/Makefile ===
#
# Makefile for the Linux kernel device drivers.
#
# 15 Sep 2000, Christoph Hellwig <hch@infradead.org>
# Rewritten to use lists instead of if-statements.
#


mod-subdirs :=	dio hil mtd sbus video macintosh usb input telephony sgi ide \
		message/i2o message/fusion scsi md ieee1394 pnp isdn atm \
		fc4 net/hamradio i2c acpi bluetooth

subdir-y :=	parport char block net sound misc media cdrom hotplug
subdir-m :=	$(subdir-y)


subdir-$(CONFIG_DIO)		+= dio
subdir-$(CONFIG_PCI)		+= pci
subdir-$(CONFIG_GSC)		+= gsc
subdir-$(CONFIG_HIL)		+= hil
subdir-$(CONFIG_PCMCIA)		+= pcmcia
subdir-$(CONFIG_MTD)		+= mtd
subdir-$(CONFIG_SBUS)		+= sbus
subdir-$(CONFIG_ZORRO)		+= zorro
subdir-$(CONFIG_NUBUS)		+= nubus
subdir-$(CONFIG_TC)		+= tc
subdir-$(CONFIG_VT)		+= video
subdir-$(CONFIG_MAC)		+= macintosh
subdir-$(CONFIG_ALL_PPC)	+= macintosh
subdir-$(CONFIG_USB)		+= usb
subdir-$(CONFIG_INPUT)		+= input
subdir-$(CONFIG_PHONE)		+= telephony
subdir-$(CONFIG_SGI)		+= sgi
subdir-$(CONFIG_IDE)		+= ide
subdir-$(CONFIG_SCSI)		+= scsi
subdir-$(CONFIG_I2O)		+= message/i2o
subdir-$(CONFIG_FUSION)		+= message/fusion
subdir-$(CONFIG_MD)		+= md
subdir-$(CONFIG_IEEE1394)	+= ieee1394
subdir-$(CONFIG_PNP)		+= pnp
subdir-$(CONFIG_ISDN)		+= isdn
subdir-$(CONFIG_ATM)		+= atm
subdir-$(CONFIG_FC4)		+= fc4

# CONFIG_HAMRADIO can be set without CONFIG_NETDEVICE being set  -- ch
subdir-$(CONFIG_HAMRADIO)	+= net/hamradio
subdir-$(CONFIG_I2C)		+= i2c
subdir-$(CONFIG_ACPI)		+= acpi

subdir-$(CONFIG_BLUEZ)		+= bluetooth

include $(TOPDIR)/Rules.make

=== linux/fs/Makefile ===
#
# Makefile for the Linux filesystems.
#
# 14 Sep 2000, Christoph Hellwig <hch@infradead.org>
# Rewritten to use lists instead of if-statements.
# 

O_TARGET := fs.o

export-objs :=	filesystems.o open.o dcache.o buffer.o
mod-subdirs :=	nls

obj-y :=	open.o read_write.o devices.o file_table.o buffer.o \
		super.o block_dev.o char_dev.o stat.o exec.o pipe.o namei.o \
		fcntl.o ioctl.o readdir.o select.o fifo.o locks.o \
		dcache.o inode.o attr.o bad_inode.o file.o iobuf.o dnotify.o \
		filesystems.o namespace.o seq_file.o

ifeq ($(CONFIG_QUOTA),y)
obj-y += dquot.o
else
obj-y += noquot.o
endif

subdir-$(CONFIG_PROC_FS)	+= proc
subdir-y			+= partitions

# Do not add any filesystems before this line
subdir-$(CONFIG_EXT3_FS)	+= ext3    # Before ext2 so root fs can be ext3
subdir-$(CONFIG_JBD)		+= jbd
subdir-$(CONFIG_EXT2_FS)	+= ext2
subdir-$(CONFIG_ZLIB_FS_INFLATE) += inflate_fs
subdir-$(CONFIG_CRAMFS)		+= cramfs
subdir-$(CONFIG_RAMFS)		+= ramfs
subdir-$(CONFIG_CODA_FS)	+= coda
subdir-$(CONFIG_INTERMEZZO_FS)	+= intermezzo
subdir-$(CONFIG_MINIX_FS)	+= minix
subdir-$(CONFIG_FAT_FS)		+= fat
subdir-$(CONFIG_UMSDOS_FS)	+= umsdos
subdir-$(CONFIG_MSDOS_FS)	+= msdos
subdir-$(CONFIG_VFAT_FS)	+= vfat
subdir-$(CONFIG_BFS_FS)		+= bfs
subdir-$(CONFIG_ISO9660_FS)	+= isofs
subdir-$(CONFIG_DEVFS_FS)	+= devfs
subdir-$(CONFIG_HFS_FS)		+= hfs
subdir-$(CONFIG_VXFS_FS)	+= freevxfs
subdir-$(CONFIG_NFS_FS)		+= nfs
subdir-$(CONFIG_NFSD)		+= nfsd
subdir-$(CONFIG_LOCKD)		+= lockd
subdir-$(CONFIG_NLS)		+= nls
subdir-$(CONFIG_SYSV_FS)	+= sysv
subdir-$(CONFIG_SMB_FS)		+= smbfs
subdir-$(CONFIG_NCP_FS)		+= ncpfs
subdir-$(CONFIG_HPFS_FS)	+= hpfs
subdir-$(CONFIG_NTFS_FS)	+= ntfs
subdir-$(CONFIG_UFS_FS)		+= ufs
subdir-$(CONFIG_EFS_FS)		+= efs
subdir-$(CONFIG_JFFS_FS)	+= jffs
subdir-$(CONFIG_JFFS2_FS)	+= jffs2
subdir-$(CONFIG_AFFS_FS)	+= affs
subdir-$(CONFIG_ROMFS_FS)	+= romfs
subdir-$(CONFIG_QNX4FS_FS)	+= qnx4
subdir-$(CONFIG_UDF_FS)		+= udf
subdir-$(CONFIG_AUTOFS_FS)	+= autofs
subdir-$(CONFIG_AUTOFS4_FS)	+= autofs4
subdir-$(CONFIG_ADFS_FS)	+= adfs
subdir-$(CONFIG_REISERFS_FS)	+= reiserfs
subdir-$(CONFIG_DEVPTS_FS)	+= devpts
subdir-$(CONFIG_SUN_OPENPROMFS)	+= openpromfs


obj-$(CONFIG_BINFMT_AOUT)	+= binfmt_aout.o
obj-$(CONFIG_BINFMT_SOM)	+= binfmt_som.o
obj-$(CONFIG_BINFMT_EM86)	+= binfmt_em86.o
obj-$(CONFIG_BINFMT_MISC)	+= binfmt_misc.o

# binfmt_script is always there
obj-y				+= binfmt_script.o

obj-$(CONFIG_BINFMT_ELF)	+= binfmt_elf.o

# persistent filesystems
obj-y += $(join $(subdir-y),$(subdir-y:%=/%.o))


include $(TOPDIR)/Rules.make

=== linux/arch/parisc/Makefile ===
#
# parisc/Makefile
#
# This file is included by the global makefile so that you can add your own
# architecture-specific flags and dependencies. Remember to do have actions
# for "archclean" and "archdep" for cleaning up and making dependencies for
# this architecture
#
# This file is subject to the terms and conditions of the GNU General Public
# License.  See the file "COPYING" in the main directory of this archive
# for more details.
#
# Copyright (C) 1994 by Linus Torvalds
# Portions Copyright (C) 1999 The Puffin Group
#
# Modified for PA-RISC Linux by Paul Lahaie, Alex deVries, 
# Mike Shaver, Helge Deller and Martin K. Petersen
#

ifdef CONFIG_PARISC64
LINKFLAGS =-T $(TOPDIR)/arch/parisc/vmlinux64.lds $(LDFLAGS)
CROSS_COMPILE := hppa64-linux-
UTS_MACHINE := parisc64
#CFLAGS += -b hppa64-linux

else
LINKFLAGS =-T $(TOPDIR)/arch/parisc/vmlinux.lds $(LDFLAGS)
MACHINE	:= $(subst 64,,$(shell uname -m))
ifneq (${MACHINE},parisc)
# cross compilation
CROSS_COMPILE := hppa-linux-
endif
endif

OFFSET_H := $(TOPDIR)/include/asm-parisc/offset.h
FINAL_LD=$(CROSS_COMPILE)ld --warn-common --warn-section-align 

CPP=$(CC) -E
OBJCOPY=$(CROSS_COMPILE)objcopy -O binary -R .note -R .comment -S
LDFLAGS =


CFLAGS_PIPE := -pipe
CFLAGS_NSR  := -fno-strength-reduce
CFLAGS := $(CFLAGS) -D__linux__ $(CFLAGS_PIPE) $(CFLAGS_NSR)

# These should be on for older toolchains or SOM toolchains that don't
# enable them by default.
CFLAGS += -mno-space-regs -mfast-indirect-calls

# No fixed-point multiply
CFLAGS += -mdisable-fpregs

# Without this, "ld -r" results in .text sections that are too big
# (> 0x40000) for branches to reach stubs.
CFLAGS += -ffunction-sections

# select which processor to optimise for
ifdef CONFIG_PA7100
CFLAGS += -march=1.1 -mschedule=7100
endif

ifdef CONFIG_PA7200
CFLAGS += -march=1.1 -mschedule=7200
endif

ifdef CONFIG_PA7100LC
CFLAGS += -march=1.1 -mschedule=7100LC
endif

ifdef CONFIG_PA8X00
CFLAGS += -march=2.0 -mschedule=8000
endif

ASFLAGS := -D__ASSEMBLY__ -traditional

HEAD := arch/parisc/kernel/head.o 

SUBDIRS := $(SUBDIRS) $(addprefix arch/parisc/, tools kernel mm lib hpux)
CORE_FILES :=  $(addprefix arch/parisc/, kernel/pdc_cons.o kernel/process.o \
	lib/lib.a mm/mm.o kernel/kernel.o hpux/hpux.o) \
	$(CORE_FILES) arch/parisc/kernel/init_task.o
CLEAN_FILES := $(CLEAN_FILES) arch/parisc/tools/offset.[hs] 

ifdef CONFIG_PARISC64
HEAD := arch/parisc/kernel/head64.o
endif

LIBS := `$(CC) -print-libgcc-file-name` $(TOPDIR)/arch/parisc/lib/lib.a $(LIBS) 

SUBDIRS := $(SUBDIRS) arch/parisc/math-emu
DRIVERS := $(DRIVERS) arch/parisc/math-emu/math.o

ifdef CONFIG_KWDB
SUBDIRS := $(SUBDIRS) arch/parisc/kdb
DRIVERS := $(DRIVERS) arch/parisc/kdb/kdb.o

arch/parisc/kdb: dummy
	$(MAKE) linuxsubdirs SUBDIRS=arch/parisc/kdb
endif

arch/parisc/kernel: dummy
	$(MAKE) linuxsubdirs SUBDIRS=arch/parisc/kernel

arch/parisc/mm: dummy
	$(MAKE) linuxsubdirs SUBDIRS=arch/parisc/mm

palo: vmlinux
	@if [ $$(palo -f /dev/null >/dev/null 2>&1 ; echo $$?) != 2 ]; then \
		echo 'ERROR: Please install palo first (apt-get install palo)';\
		echo 'or build it from source and install it somewhere in your $$PATH';\
		false; \
	fi
	@if [ ! -f ./palo.conf ]; then \
		cp arch/parisc/defpalo.conf palo.conf; \
		echo 'A generic palo config file (./palo.conf) has been created for you.'; \
		echo 'You should check it and re-run "make palo".'; \
		echo 'WARNING: the "lifimage" file is now placed in this directory by default!'; \
		false; \
	fi
	palo -f ./palo.conf

oldpalo: vmlinux
	export TOPDIR=`pwd`; \
	unset STRIP LDFLAGS CPP CPPFLAGS AFLAGS CFLAGS CC LD; cd ../palo && make lifimage

Image: palo

Image-clean:

ramdisk.o:

zImage: palo

bzImage: palo

compressed: zImage

install: 

archmrproper:
	rm -f $(OFFSET_H)

archclean:

archdep: $(OFFSET_H)

$(OFFSET_H): include/linux/version.h
	$(MAKE) -C $(TOPDIR)/arch/$(ARCH)/tools all

.PHONY: $(OFFSET_H)

=== linux/drivers/char/Makefile ===
#
# Makefile for the kernel character device drivers.
#
# Note! Dependencies are done automagically by 'make dep', which also
# removes any old dependencies. DON'T put your own dependencies here
# unless it's something special (ie not a .c file).
#
# Note 2! The CFLAGS definitions are now inherited from the
# parent makes..
#

#
# This file contains the font map for the default (hardware) font
#
FONTMAPFILE = cp437.uni

O_TARGET := char.o

obj-y	 += mem.o tty_io.o n_tty.o tty_ioctl.o raw.o pty.o misc.o random.o

# All of the (potential) objects that export symbols.
# This list comes from 'grep -l EXPORT_SYMBOL *.[hc]'.

export-objs     :=	busmouse.o console.o hp_psaux.o \
			keyboard.o sysrq.o misc.o pty.o random.o selection.o \
                        serial.o sonypi.o tty_io.o tty_ioctl.o generic_serial.o

mod-subdirs	:=	joystick ftape drm drm-4.0 pcmcia

list-multi	:=	

KEYMAP   =defkeymap.o
KEYBD    =pc_keyb.o
CONSOLE  =console.o
SERIAL   =serial.o

ifeq ($(ARCH),s390)
  KEYMAP   =
  KEYBD    =
  CONSOLE  =
  SERIAL   =
endif

ifeq ($(ARCH),mips)
  ifneq ($(CONFIG_PC_KEYB),y)
    KEYBD    =
  endif
endif

ifeq ($(ARCH),s390x)
  KEYMAP   =
  KEYBD    =
  CONSOLE  =
  SERIAL   =
endif

ifeq ($(ARCH),m68k)
   ifdef CONFIG_AMIGA
      KEYBD = amikeyb.o
   else
      KEYBD =
   endif
   SERIAL   =
endif

ifeq ($(ARCH),parisc)
   ifdef CONFIG_GSC_PS2
      KEYBD   = hp_psaux.o hp_keyb.o
   else
      KEYBD   =
   endif
   ifdef CONFIG_PDC_CONSOLE
      CONSOLE += pdc_console.o
   endif
endif

ifeq ($(ARCH),arm)
  ifneq ($(CONFIG_PC_KEYMAP),y)
    KEYMAP   =
  endif
  ifneq ($(CONFIG_PC_KEYB),y)
    KEYBD    =
  endif
endif

ifeq ($(ARCH),sh)
  KEYMAP   =
  KEYBD    =
  CONSOLE  =
  ifeq ($(CONFIG_SH_HP600),y)
  KEYMAP   = defkeymap.o
  KEYBD    = scan_keyb.o hp600_keyb.o
  CONSOLE  = console.o
  endif
  ifeq ($(CONFIG_SH_DMIDA),y)
  # DMIDA does not connect the HD64465 PS/2 keyboard port
  # but we allow for USB keyboards to be plugged in.
  KEYMAP   = defkeymap.o
  KEYBD    = # hd64465_keyb.o pc_keyb.o
  CONSOLE  = console.o
  endif
  ifeq ($(CONFIG_SH_EC3104),y)
  KEYMAP   = defkeymap.o
  KEYBD    = ec3104_keyb.o
  CONSOLE  = console.o
  endif
  ifeq ($(CONFIG_SH_DREAMCAST),y)
  KEYMAP   = defkeymap.o
  KEYBD    =
  CONSOLE  = console.o
  endif
endif

ifeq ($(CONFIG_DECSTATION),y)
  KEYMAP   =
  KEYBD    =
  SERIAL   = decserial.o
endif

ifeq ($(CONFIG_BAGET_MIPS),y)
  KEYBD    =
  SERIAL   =
endif

ifeq ($(CONFIG_NINO),y)
  SERIAL   =
endif

ifneq ($(CONFIG_SUN_SERIAL),)
  SERIAL   =
endif

ifeq ($(CONFIG_QTRONIX_KEYBOARD),y)
  KEYBD    = qtronix.o
  KEYMAP   = qtronixmap.o
endif

obj-$(CONFIG_VT) += vt.o vc_screen.o consolemap.o consolemap_deftbl.o $(CONSOLE) selection.o
obj-$(CONFIG_SERIAL) += $(SERIAL)
obj-$(CONFIG_SERIAL_ACPI) += acpi_serial.o
obj-$(CONFIG_SERIAL_21285) += serial_21285.o
obj-$(CONFIG_SERIAL_SA1100) += serial_sa1100.o
obj-$(CONFIG_SERIAL_AMBA) += serial_amba.o

ifndef CONFIG_SUN_KEYBOARD
  obj-$(CONFIG_VT) += keyboard.o $(KEYMAP) $(KEYBD)
else
  obj-$(CONFIG_PCI) += keyboard.o $(KEYMAP)
endif

obj-$(CONFIG_HIL) += hp_keyb.o
obj-$(CONFIG_MAGIC_SYSRQ) += sysrq.o
obj-$(CONFIG_ATARI_DSP56K) += dsp56k.o
obj-$(CONFIG_ROCKETPORT) += rocket.o
obj-$(CONFIG_MOXA_SMARTIO) += mxser.o
obj-$(CONFIG_MOXA_INTELLIO) += moxa.o
obj-$(CONFIG_DIGI) += pcxx.o
obj-$(CONFIG_DIGIEPCA) += epca.o
obj-$(CONFIG_CYCLADES) += cyclades.o
obj-$(CONFIG_STALLION) += stallion.o
obj-$(CONFIG_ISTALLION) += istallion.o
obj-$(CONFIG_COMPUTONE) += ip2.o ip2main.o
obj-$(CONFIG_RISCOM8) += riscom8.o
obj-$(CONFIG_ISI) += isicom.o
obj-$(CONFIG_ESPSERIAL) += esp.o
obj-$(CONFIG_SYNCLINK) += synclink.o
obj-$(CONFIG_N_HDLC) += n_hdlc.o
obj-$(CONFIG_SPECIALIX) += specialix.o
obj-$(CONFIG_AMIGA_BUILTIN_SERIAL) += amiserial.o
obj-$(CONFIG_A2232) += ser_a2232.o generic_serial.o
obj-$(CONFIG_SX) += sx.o generic_serial.o
obj-$(CONFIG_RIO) += rio/rio.o generic_serial.o
obj-$(CONFIG_SH_SCI) += sh-sci.o generic_serial.o
obj-$(CONFIG_SERIAL167) += serial167.o
obj-$(CONFIG_MVME147_SCC) += generic_serial.o vme_scc.o
obj-$(CONFIG_MVME162_SCC) += generic_serial.o vme_scc.o
obj-$(CONFIG_BVME6000_SCC) += generic_serial.o vme_scc.o
obj-$(CONFIG_SERIAL_TX3912) += generic_serial.o serial_tx3912.o

subdir-$(CONFIG_RIO) += rio
subdir-$(CONFIG_INPUT) += joystick

obj-$(CONFIG_ATIXL_BUSMOUSE) += atixlmouse.o
obj-$(CONFIG_LOGIBUSMOUSE) += logibusmouse.o
obj-$(CONFIG_PRINTER) += lp.o

ifeq ($(CONFIG_INPUT),y)
obj-y += joystick/js.o
endif

obj-$(CONFIG_BUSMOUSE) += busmouse.o
obj-$(CONFIG_DTLK) += dtlk.o
obj-$(CONFIG_R3964) += n_r3964.o
obj-$(CONFIG_APPLICOM) += applicom.o
obj-$(CONFIG_SONYPI) += sonypi.o
obj-$(CONFIG_MS_BUSMOUSE) += msbusmouse.o
obj-$(CONFIG_82C710_MOUSE) += qpmouse.o
obj-$(CONFIG_AMIGAMOUSE) += amigamouse.o
obj-$(CONFIG_ATARIMOUSE) += atarimouse.o
obj-$(CONFIG_ADBMOUSE) += adbmouse.o
obj-$(CONFIG_PC110_PAD) += pc110pad.o
obj-$(CONFIG_RTC) += rtc.o
obj-$(CONFIG_GENRTC) += genrtc.o
obj-$(CONFIG_EFI_RTC) += efirtc.o
ifeq ($(CONFIG_PPC),)
  obj-$(CONFIG_NVRAM) += nvram.o
endif
obj-$(CONFIG_TOSHIBA) += toshiba.o
obj-$(CONFIG_I8K) += i8k.o
obj-$(CONFIG_DS1620) += ds1620.o
obj-$(CONFIG_INTEL_RNG) += i810_rng.o

obj-$(CONFIG_QIC02_TAPE) += tpqic02.o

subdir-$(CONFIG_FTAPE) += ftape
subdir-$(CONFIG_DRM_OLD) += drm-4.0
subdir-$(CONFIG_DRM_NEW) += drm
subdir-$(CONFIG_PCMCIA) += pcmcia
subdir-$(CONFIG_AGP) += agp

ifeq ($(CONFIG_FTAPE),y)
obj-y       += ftape/ftape.o
endif

obj-$(CONFIG_H8) += h8.o
obj-$(CONFIG_PPDEV) += ppdev.o
obj-$(CONFIG_DZ) += dz.o
obj-$(CONFIG_NWBUTTON) += nwbutton.o
obj-$(CONFIG_NWFLASH) += nwflash.o

# Only one watchdog can succeed. We probe the hardware watchdog
# drivers first, then the softdog driver.  This means if your hardware
# watchdog dies or is 'borrowed' for some reason the software watchdog
# still gives you some cover.

obj-$(CONFIG_PCWATCHDOG) += pcwd.o
obj-$(CONFIG_ACQUIRE_WDT) += acquirewdt.o
obj-$(CONFIG_ADVANTECH_WDT) += advantechwdt.o
obj-$(CONFIG_IB700_WDT) += ib700wdt.o
obj-$(CONFIG_MIXCOMWD) += mixcomwd.o
obj-$(CONFIG_60XX_WDT) += sbc60xxwdt.o
obj-$(CONFIG_WDT) += wdt.o
obj-$(CONFIG_WDTPCI) += wdt_pci.o
obj-$(CONFIG_21285_WATCHDOG) += wdt285.o
obj-$(CONFIG_977_WATCHDOG) += wdt977.o
obj-$(CONFIG_I810_TCO) += i810-tco.o
obj-$(CONFIG_MACHZ_WDT) += machzwd.o
obj-$(CONFIG_SH_WDT) += shwdt.o
obj-$(CONFIG_EUROTECH_WDT) += eurotechwdt.o
obj-$(CONFIG_SOFT_WATCHDOG) += softdog.o

subdir-$(CONFIG_MWAVE) += mwave
ifeq ($(CONFIG_MWAVE),y)
  obj-y += mwave/mwave.o
endif

include $(TOPDIR)/Rules.make

fastdep:

conmakehash: conmakehash.c
	$(HOSTCC) $(HOSTCFLAGS) -o conmakehash conmakehash.c

consolemap_deftbl.c: $(FONTMAPFILE) conmakehash
	./conmakehash $(FONTMAPFILE) > consolemap_deftbl.c

consolemap_deftbl.o: consolemap_deftbl.c $(TOPDIR)/include/linux/types.h

.DELETE_ON_ERROR:

defkeymap.c: defkeymap.map
	set -e ; loadkeys --mktable $< | sed -e 's/^static *//' > $@

qtronixmap.c: qtronixmap.map
	set -e ; loadkeys --mktable $< | sed -e 's/^static *//' > $@

=== linux/drivers/scsi/Makefile ===
#
# Makefile for linux/drivers/scsi
#
# 30 May 2000, Christoph Hellwig <hch@infradead.org>
# Rewritten to use lists instead of if-statements.
#
# 20 Sep 2000, Torben Mathiasen <tmm@image.dk>
# Changed link order to reflect new scsi initialization.
#
# *!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!
# The link order must be, SCSI Core, SCSI HBA drivers, and
# lastly SCSI peripheral drivers (disk/tape/cdrom/etc.) to
# satisfy certain initialization assumptions in the SCSI layer.
# *!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!


CFLAGS_aha152x.o =   -DAHA152X_STAT -DAUTOCONF
CFLAGS_gdth.o    = # -DDEBUG_GDTH=2 -D__SERIAL__ -D__COM2__ -DGDTH_STATISTICS
CFLAGS_seagate.o =   -DARBITRATE -DPARITY -DSEAGATE_USE_ASM


O_TARGET := scsidrv.o

export-objs	:= scsi_syms.o 53c700.o
mod-subdirs	:= pcmcia ../acorn/scsi


subdir-$(CONFIG_SCSI_AACRAID)	+= aacraid
subdir-$(CONFIG_SCSI_AIC7XXX)	+= aic7xxx
subdir-$(CONFIG_PCMCIA)		+= pcmcia


obj-$(CONFIG_SCSI)		+= scsi_mod.o

obj-$(CONFIG_A4000T_SCSI)	+= amiga7xx.o	53c7xx.o
obj-$(CONFIG_A4091_SCSI)	+= amiga7xx.o	53c7xx.o
obj-$(CONFIG_BLZ603EPLUS_SCSI)	+= amiga7xx.o	53c7xx.o
obj-$(CONFIG_WARPENGINE_SCSI)	+= amiga7xx.o	53c7xx.o
obj-$(CONFIG_A3000_SCSI)	+= a3000.o	wd33c93.o
obj-$(CONFIG_A2091_SCSI)	+= a2091.o	wd33c93.o
obj-$(CONFIG_GVP11_SCSI)	+= gvp11.o	wd33c93.o
obj-$(CONFIG_MVME147_SCSI)	+= mvme147.o	wd33c93.o
obj-$(CONFIG_SGIWD93_SCSI)	+= sgiwd93.o	wd33c93.o
obj-$(CONFIG_CYBERSTORM_SCSI)	+= NCR53C9x.o	cyberstorm.o
obj-$(CONFIG_CYBERSTORMII_SCSI)	+= NCR53C9x.o	cyberstormII.o
obj-$(CONFIG_BLZ2060_SCSI)	+= NCR53C9x.o	blz2060.o
obj-$(CONFIG_BLZ1230_SCSI)	+= NCR53C9x.o	blz1230.o
obj-$(CONFIG_FASTLANE_SCSI)	+= NCR53C9x.o	fastlane.o
obj-$(CONFIG_OKTAGON_SCSI)	+= NCR53C9x.o	oktagon_esp.o	oktagon_io.o
obj-$(CONFIG_ATARI_SCSI)	+= atari_scsi.o
obj-$(CONFIG_MAC_SCSI)		+= mac_scsi.o
obj-$(CONFIG_SCSI_MAC_ESP)	+= mac_esp.o	NCR53C9x.o
obj-$(CONFIG_SUN3_SCSI)		+= sun3_scsi.o
obj-$(CONFIG_MVME16x_SCSI)	+= mvme16x.o	53c7xx.o
obj-$(CONFIG_BVME6000_SCSI)	+= bvme6000.o	53c7xx.o
obj-$(CONFIG_SCSI_SIM710)	+= sim710.o
obj-$(CONFIG_SCSI_ADVANSYS)	+= advansys.o
obj-$(CONFIG_SCSI_PCI2000)	+= pci2000.o
obj-$(CONFIG_SCSI_PCI2220I)	+= pci2220i.o
obj-$(CONFIG_SCSI_PSI240I)	+= psi240i.o
obj-$(CONFIG_SCSI_BUSLOGIC)	+= BusLogic.o
obj-$(CONFIG_SCSI_DPT_I2O)	+= dpt_i2o.o
obj-$(CONFIG_SCSI_U14_34F)	+= u14-34f.o
obj-$(CONFIG_SCSI_ULTRASTOR)	+= ultrastor.o
obj-$(CONFIG_SCSI_AHA152X)	+= aha152x.o
obj-$(CONFIG_SCSI_AHA1542)	+= aha1542.o
obj-$(CONFIG_SCSI_AHA1740)	+= aha1740.o
ifeq ($(CONFIG_SCSI_AACRAID),y)
  obj-$(CONFIG_SCSI_AACRAID)	+= aacraid/aacraid.o
endif
ifeq ($(CONFIG_SCSI_AIC7XXX),y)
obj-$(CONFIG_SCSI_AIC7XXX)	+= aic7xxx/aic7xxx_drv.o
endif
obj-$(CONFIG_SCSI_AIC7XXX_OLD)	+= aic7xxx_old.o
obj-$(CONFIG_SCSI_IPS)		+= ips.o
obj-$(CONFIG_SCSI_FD_MCS)	+= fd_mcs.o
obj-$(CONFIG_SCSI_FUTURE_DOMAIN)+= fdomain.o
obj-$(CONFIG_SCSI_IN2000)	+= in2000.o
obj-$(CONFIG_SCSI_GENERIC_NCR5380) += g_NCR5380.o
obj-$(CONFIG_SCSI_NCR53C406A)	+= NCR53c406a.o
obj-$(CONFIG_SCSI_NCR_D700)	+= NCR_D700.o 53c700.o
obj-$(CONFIG_SCSI_SYM53C416)	+= sym53c416.o
obj-$(CONFIG_SCSI_QLOGIC_FAS)	+= qlogicfas.o
obj-$(CONFIG_SCSI_QLOGIC_ISP)	+= qlogicisp.o 
obj-$(CONFIG_SCSI_QLOGIC_FC)	+= qlogicfc.o 
obj-$(CONFIG_SCSI_QLOGIC_1280)	+= qla1280.o 
obj-$(CONFIG_SCSI_PAS16)	+= pas16.o
obj-$(CONFIG_SCSI_SEAGATE)	+= seagate.o
obj-$(CONFIG_SCSI_FD_8xx)	+= seagate.o
obj-$(CONFIG_SCSI_T128)		+= t128.o
obj-$(CONFIG_SCSI_DMX3191D)	+= dmx3191d.o
obj-$(CONFIG_SCSI_DTC3280)	+= dtc.o
obj-$(CONFIG_SCSI_NCR53C7xx)	+= 53c7,8xx.o 
subdir-$(CONFIG_SCSI_SYM53C8XX_2)	+= sym53c8xx_2
ifeq ($(CONFIG_SCSI_SYM53C8XX_2),y)
  obj-$(CONFIG_SCSI_SYM53C8XX_2)	+= sym53c8xx_2/sym53c8xx.o
endif
obj-$(CONFIG_SCSI_SYM53C8XX)	+= sym53c8xx.o 
obj-$(CONFIG_SCSI_NCR53C8XX)	+= ncr53c8xx.o 
obj-$(CONFIG_SCSI_EATA_DMA)	+= eata_dma.o
obj-$(CONFIG_SCSI_EATA_PIO)	+= eata_pio.o
obj-$(CONFIG_SCSI_7000FASST)	+= wd7000.o
obj-$(CONFIG_SCSI_MCA_53C9X)	+= NCR53C9x.o	mca_53c9x.o
obj-$(CONFIG_SCSI_IBMMCA)	+= ibmmca.o
obj-$(CONFIG_SCSI_EATA)		+= eata.o
obj-$(CONFIG_SCSI_DC390T)	+= tmscsim.o
obj-$(CONFIG_SCSI_AM53C974)	+= AM53C974.o
obj-$(CONFIG_SCSI_MEGARAID)	+= megaraid.o
obj-$(CONFIG_SCSI_ACARD)	+= atp870u.o
obj-$(CONFIG_SCSI_SUNESP)	+= esp.o
obj-$(CONFIG_SCSI_GDTH)		+= gdth.o
obj-$(CONFIG_SCSI_INITIO)	+= initio.o
obj-$(CONFIG_SCSI_INIA100)	+= a100u2w.o
obj-$(CONFIG_SCSI_QLOGICPTI)	+= qlogicpti.o
obj-$(CONFIG_BLK_DEV_IDESCSI)	+= ide-scsi.o
obj-$(CONFIG_SCSI_MESH)		+= mesh.o
obj-$(CONFIG_SCSI_MAC53C94)	+= mac53c94.o
obj-$(CONFIG_SCSI_PLUTO)	+= pluto.o
obj-$(CONFIG_SCSI_DECNCR)	+= NCR53C9x.o	dec_esp.o
obj-$(CONFIG_BLK_DEV_3W_XXXX_RAID) += 3w-xxxx.o
obj-$(CONFIG_SCSI_ZALON)	+= zalon7xx_mod.o
obj-$(CONFIG_SCSI_PPA)		+= ppa.o
obj-$(CONFIG_SCSI_IMM)		+= imm.o
obj-$(CONFIG_JAZZ_ESP)		+= NCR53C9x.o	jazz_esp.o
obj-$(CONFIG_SUN3X_ESP)		+= NCR53C9x.o	sun3x_esp.o
obj-$(CONFIG_SCSI_DEBUG)	+= scsi_debug.o
obj-$(CONFIG_SCSI_FCAL)		+= fcal.o
obj-$(CONFIG_SCSI_CPQFCTS)	+= cpqfc.o
obj-$(CONFIG_SCSI_LASI700)	+= lasi700.o 53c700.o

subdir-$(CONFIG_ARCH_ACORN)	+= ../acorn/scsi
obj-$(CONFIG_ARCH_ACORN)	+= ../acorn/scsi/acorn-scsi.o

obj-$(CONFIG_CHR_DEV_ST)	+= st.o
obj-$(CONFIG_CHR_DEV_OSST)	+= osst.o
obj-$(CONFIG_BLK_DEV_SD)	+= sd_mod.o
obj-$(CONFIG_BLK_DEV_SR)	+= sr_mod.o
obj-$(CONFIG_CHR_DEV_SG)	+= sg.o

list-multi	:= scsi_mod.o sd_mod.o sr_mod.o initio.o a100u2w.o cpqfc.o \
			zalon7xx_mod.o
scsi_mod-objs	:= scsi.o hosts.o scsi_ioctl.o constants.o \
			scsicam.o scsi_proc.o scsi_error.o \
			scsi_obsolete.o scsi_queue.o scsi_lib.o \
			scsi_merge.o scsi_dma.o scsi_scan.o \
			scsi_syms.o
sd_mod-objs	:= sd.o
sr_mod-objs	:= sr.o sr_ioctl.o sr_vendor.o
initio-objs	:= ini9100u.o i91uscsi.o
a100u2w-objs	:= inia100.o i60uscsi.o
zalon7xx_mod-objs := zalon7xx.o ncr53c8xx.o
cpqfc-objs	:= cpqfcTSinit.o cpqfcTScontrol.o cpqfcTSi2c.o \
		   cpqfcTSworker.o cpqfcTStrigger.o

include $(TOPDIR)/Rules.make


scsi_mod.o: $(scsi_mod-objs)
	$(LD) -r -o $@ $(scsi_mod-objs)

sd_mod.o: $(sd_mod-objs)
	$(LD) -r -o $@ $(sd_mod-objs)

sr_mod.o: $(sr_mod-objs)
	$(LD) -r -o $@ $(sr_mod-objs)

initio.o: $(initio-objs)
	$(LD) -r -o $@ $(initio-objs)

a100u2w.o: $(a100u2w-objs)
	$(LD) -r -o $@ $(a100u2w-objs)

zalon7xx_mod.o: $(zalon7xx_mod-objs)
	$(LD) -r -o $@ $(zalon7xx_mod-objs)

cpqfc.o: $(cpqfc-objs)
	$(LD) -r -o $@ $(cpqfc-objs)

53c8xx_d.h: 53c7,8xx.scr script_asm.pl
	ln -sf 53c7,8xx.scr fake8.c
	$(CPP) $(CPPFLAGS) -traditional -DCHIP=810 fake8.c | grep -v '^#' | $(PERL) script_asm.pl 
	mv script.h 53c8xx_d.h
	mv scriptu.h 53c8xx_u.h
	rm fake8.c

53c8xx_u.h: 53c8xx_d.h

53c7,8xx.o: 53c8xx_u.h

53c7xx_d.h: 53c7xx.scr script_asm.pl
	ln -sf 53c7xx.scr fake7.c
	$(CPP) $(CPPFLAGS) -traditional -DCHIP=710 fake7.c | grep -v '^#' | $(PERL) -s script_asm.pl -ncr710
	mv script.h 53c7xx_d.h
	mv scriptu.h 53c7xx_u.h
	rm fake7.c

53c7xx_u.h: 53c7xx_d.h

53c7xx.o : 53c7xx_d.h

sim710_d.h: sim710.scr script_asm.pl
	ln -sf sim710.scr fake7.c
	$(CPP) $(CPPFLAGS) -traditional -DCHIP=710 fake7.c | grep -v '^#' | $(PERL) -s script_asm.pl -ncr710
	mv script.h sim710_d.h
	mv scriptu.h sim710_u.h
	rm fake7.c

sim710_u.h: sim710_d.h

sim710.o : sim710_d.h

53c700_d.h: 53c700.scr script_asm.pl
	$(PERL) -s script_asm.pl -ncr7x0_family < 53c700.scr
	rm -f scriptu.h
	mv script.h 53c700_d.h

53c700.o: 53c700_d.h

=== linux/drivers/sound/Makefile ===
# Makefile for the Linux sound card driver
#
# 18 Apr 1998, Michael Elizabeth Chastain, <mailto:mec@shout.net>
# Rewritten to use lists instead of if-statements.


# All of the (potential) objects that export symbols.
# This list comes from 'grep -l EXPORT_SYMBOL *.[hc]'.

export-objs	:=  ad1848.o audio_syms.o midi_syms.o mpu401.o \
		    msnd.o opl3.o sb_common.o sequencer_syms.o \
		    sound_core.o sound_syms.o uart401.o	\
		    nm256_audio.o ac97.o ac97_codec.o aci.o

# Each configuration option enables a list of files.

obj-$(CONFIG_SOUND)		+= soundcore.o
obj-$(CONFIG_SOUND_OSS)		+= sound.o
obj-$(CONFIG_SOUND_CS4232)	+= cs4232.o ad1848.o 

# Please leave it as is, cause the link order is significant !

obj-$(CONFIG_SOUND_AEDSP16)	+= aedsp16.o
obj-$(CONFIG_SOUND_PSS)		+= pss.o ad1848.o mpu401.o
obj-$(CONFIG_SOUND_TRIX)	+= trix.o ad1848.o sb_lib.o uart401.o
obj-$(CONFIG_SOUND_OPL3SA1)	+= opl3sa.o ad1848.o uart401.o
obj-$(CONFIG_SOUND_SSCAPE)	+= sscape.o ad1848.o mpu401.o
obj-$(CONFIG_SOUND_MAD16)	+= mad16.o ad1848.o sb_lib.o uart401.o
obj-$(CONFIG_SOUND_CS4232)	+= cs4232.o uart401.o
obj-$(CONFIG_SOUND_OPL3SA2)	+= opl3sa2.o ad1848.o mpu401.o
obj-$(CONFIG_SOUND_MSS)		+= ad1848.o
obj-$(CONFIG_SOUND_PAS)		+= pas2.o sb.o sb_lib.o uart401.o
obj-$(CONFIG_SOUND_SB)		+= sb.o sb_lib.o uart401.o
obj-$(CONFIG_SOUND_WAVEFRONT)	+= wavefront.o
obj-$(CONFIG_SOUND_MAUI)	+= maui.o mpu401.o
obj-$(CONFIG_SOUND_MPU401)	+= mpu401.o
obj-$(CONFIG_SOUND_UART6850)	+= uart6850.o
obj-$(CONFIG_SOUND_GUS)		+= gus.o ad1848.o
obj-$(CONFIG_SOUND_ADLIB)	+= adlib_card.o opl3.o
obj-$(CONFIG_SOUND_YM3812)	+= opl3.o
obj-$(CONFIG_SOUND_VMIDI)	+= v_midi.o
obj-$(CONFIG_SOUND_VIDC)	+= vidc_mod.o
obj-$(CONFIG_SOUND_WAVEARTIST)	+= waveartist.o
obj-$(CONFIG_SOUND_SGALAXY)	+= sgalaxy.o ad1848.o
obj-$(CONFIG_SOUND_AD1816)	+= ad1816.o
obj-$(CONFIG_SOUND_AD1889)      += ad1889.o ac97_codec.o
obj-$(CONFIG_SOUND_ACI_MIXER)	+= aci.o
obj-$(CONFIG_SOUND_AWE32_SYNTH)	+= awe_wave.o

obj-$(CONFIG_SOUND_VIA82CXXX)	+= via82cxxx_audio.o ac97_codec.o
ifeq ($(CONFIG_MIDI_VIA82CXXX),y)
  obj-$(CONFIG_SOUND_VIA82CXXX) += sound.o uart401.o
endif
obj-$(CONFIG_SOUND_YMFPCI)	+= ymfpci.o ac97_codec.o
ifeq ($(CONFIG_SOUND_YMFPCI_LEGACY),y)
  obj-$(CONFIG_SOUND_YMFPCI)    += opl3.o uart401.o
endif
obj-$(CONFIG_SOUND_MSNDCLAS)	+= msnd.o msnd_classic.o
obj-$(CONFIG_SOUND_MSNDPIN)	+= msnd.o msnd_pinnacle.o
obj-$(CONFIG_SOUND_VWSND)	+= vwsnd.o
obj-$(CONFIG_SOUND_NM256)	+= nm256_audio.o ac97.o
obj-$(CONFIG_SOUND_ICH)		+= i810_audio.o ac97_codec.o
obj-$(CONFIG_SOUND_SONICVIBES)	+= sonicvibes.o
obj-$(CONFIG_SOUND_CMPCI)	+= cmpci.o
obj-$(CONFIG_SOUND_ES1370)	+= es1370.o
obj-$(CONFIG_SOUND_ES1371)	+= es1371.o ac97_codec.o
obj-$(CONFIG_SOUND_VRC5477)	+= nec_vrc5477.o ac97_codec.o
obj-$(CONFIG_SOUND_ESSSOLO1)	+= esssolo1.o
obj-$(CONFIG_SOUND_FUSION)	+= cs46xx.o ac97_codec.o
obj-$(CONFIG_SOUND_MAESTRO)	+= maestro.o
obj-$(CONFIG_SOUND_MAESTRO3)	+= maestro3.o ac97_codec.o
obj-$(CONFIG_SOUND_TRIDENT)	+= trident.o ac97_codec.o
obj-$(CONFIG_SOUND_HARMONY)	+= harmony.o
obj-$(CONFIG_SOUND_EMU10K1)	+= ac97_codec.o
obj-$(CONFIG_SOUND_RME96XX)     += rme96xx.o
obj-$(CONFIG_SOUND_BT878)	+= btaudio.o
obj-$(CONFIG_SOUND_EMU10K1)	+= ac97_codec.o
obj-$(CONFIG_SOUND_IT8172)     += ite8172.o ac97_codec.o

ifeq ($(CONFIG_MIDI_EMU10K1),y)
  obj-$(CONFIG_SOUND_EMU10K1)	+= sound.o
endif

subdir-$(CONFIG_SOUND_EMU10K1) += emu10k1
subdir-$(CONFIG_SOUND_CS4281) += cs4281

ifeq ($(CONFIG_SOUND_EMU10K1),y)
  obj-y += emu10k1/emu10k1.o
endif

ifeq ($(CONFIG_SOUND_CS4281),y)
  obj-y += cs4281/cs4281.o
endif

subdir-$(CONFIG_DMASOUND) += dmasound

ifeq ($(CONFIG_DMASOUND),y)
  obj-y += dmasound/dmasound.o
endif


# Declare multi-part drivers.

list-multi	:= sound.o gus.o pas2.o sb.o sb_lib.o vidc_mod.o \
    soundcore.o wavefront.o

sound-objs	:= 							\
    dev_table.o soundcard.o sound_syms.o		\
    audio.o audio_syms.o dmabuf.o					\
    midi_syms.o midi_synth.o midibuf.o					\
    sequencer.o sequencer_syms.o sound_timer.o sys_timer.o

soundcore-objs	:= sound_core.o sound_firmware.o

gus-objs	:= gus_card.o gus_midi.o gus_vol.o gus_wave.o ics2101.o
pas2-objs	:= pas2_card.o pas2_midi.o pas2_mixer.o pas2_pcm.o
sb-objs		:= sb_card.o
sb_lib-objs	:= sb_common.o sb_audio.o sb_midi.o sb_mixer.o sb_ess.o
vidc_mod-objs	:= vidc.o vidc_fill.o
wavefront-objs  := wavfront.o wf_midi.o yss225.o


O_TARGET	:= sounddrivers.o

include $(TOPDIR)/Rules.make



# Link rules for multi-part drivers.

sound.o: $(sound-objs)
	$(LD) -r -o $@ $(sound-objs)

soundcore.o: $(soundcore-objs)
	$(LD) -r -o $@ $(soundcore-objs)

gus.o: $(gus-objs)
	$(LD) -r -o $@ $(gus-objs)

pas2.o: $(pas2-objs)
	$(LD) -r -o $@ $(pas2-objs)

sb.o: $(sb-objs)
	$(LD) -r -o $@ $(sb-objs)

sb_lib.o: $(sb_lib-objs)
	$(LD) -r -o $@ $(sb_lib-objs)

vidc_mod.o: $(vidc_mod-objs)
	$(LD) -r -o $@ $(vidc_mod-objs)

wavefront.o: $(wavefront-objs)
	$(LD) -r -o $@ $(wavefront-objs)

# Firmware files that need translation
#
# The translated files are protected by a file that keeps track
# of what name was used to build them.  If the name changes, they
# will be forced to be remade.
#
# First make the utilities.

bin2hex: bin2hex.c
	$(HOSTCC) $(HOSTCFLAGS) -o bin2hex bin2hex.c

hex2hex: hex2hex.c
	$(HOSTCC) $(HOSTCFLAGS) -o hex2hex hex2hex.c




# Turtle Beach Maui / Tropez

maui.o: maui_boot.h

ifeq ($(CONFIG_MAUI_HAVE_BOOT),y)
    maui_boot.h: $(patsubst "%", %, $(CONFIG_MAUI_BOOT_FILE)) bin2hex
	./bin2hex -i maui_os < $(CONFIG_MAUI_BOOT_FILE) > $@
else
    maui_boot.h:
	(							\
	    echo 'static unsigned char * maui_os = NULL;';	\
	    echo 'static int maui_osLen = 0;';			\
	) > $@
endif
	@ ( \
	    echo 'ifeq ($(strip $(CONFIG_MAUI_HAVE_BOOT) $(CONFIG_MAUI_BOOT_FILE)),$$(strip $$(CONFIG_MAUI_HAVE_BOOT) $$(CONFIG_MAUI_BOOT_FILE)))'; \
	    echo 'FILES_BOOT_UP_TO_DATE += $@'; \
	    echo 'endif' \
	) > .$@.boot



# Turtle Beach MultiSound

ifeq ($(CONFIG_MSNDCLAS_HAVE_BOOT),y)
    msnd_classic.o: msndperm.c msndinit.c

    msndperm.c: $(patsubst "%", %, $(CONFIG_MSNDCLAS_PERM_FILE)) bin2hex
	./bin2hex msndperm < $(CONFIG_MSNDCLAS_PERM_FILE) > $@
	@ ( \
	    echo 'ifeq ($(strip $(CONFIG_MSNDCLAS_HAVE_BOOT) $(CONFIG_MSNDCLAS_PERM_FILE)),$$(strip $$(CONFIG_MSNDCLAS_HAVE_BOOT) $$(CONFIG_MSNDCLAS_PERM_FILE)))'; \
	    echo 'FILES_BOOT_UP_TO_DATE += $@'; \
	    echo 'endif' \
	) > .$@.boot

    msndinit.c: $(patsubst "%", %, $(CONFIG_MSNDCLAS_INIT_FILE)) bin2hex
	./bin2hex msndinit < $(CONFIG_MSNDCLAS_INIT_FILE) > $@
	@ ( \
	    echo 'ifeq ($(strip $(CONFIG_MSNDCLAS_HAVE_BOOT) $(CONFIG_MSNDCLAS_INIT_FILE)),$$(strip $$(CONFIG_MSNDCLAS_HAVE_BOOT) $$(CONFIG_MSNDCLAS_INIT_FILE)))'; \
	    echo 'FILES_BOOT_UP_TO_DATE += $@'; \
	    echo 'endif' \
	) > .$@.boot
endif

ifeq ($(CONFIG_MSNDPIN_HAVE_BOOT),y)
    msnd_pinnacle.o: pndsperm.c pndspini.c

    pndsperm.c: $(patsubst "%", %, $(CONFIG_MSNDPIN_PERM_FILE)) bin2hex
	./bin2hex pndsperm < $(CONFIG_MSNDPIN_PERM_FILE) > $@
	@ ( \
	    echo 'ifeq ($(strip $(CONFIG_MSNDPIN_HAVE_BOOT) $(CONFIG_MSNDPIN_PERM_FILE)),$$(strip $$(CONFIG_MSNDPIN_HAVE_BOOT) $$(CONFIG_MSNDPIN_PERM_FILE)))'; \
	    echo 'FILES_BOOT_UP_TO_DATE += $@'; \
	    echo 'endif' \
	) > .$@.boot

    pndspini.c: $(patsubst "%", %, $(CONFIG_MSNDPIN_INIT_FILE)) bin2hex
	./bin2hex pndspini < $(CONFIG_MSNDPIN_INIT_FILE) > $@
	@ ( \
	    echo 'ifeq ($(strip $(CONFIG_MSNDPIN_HAVE_BOOT) $(CONFIG_MSNDPIN_INIT_FILE)),$$(strip $$(CONFIG_MSNDPIN_HAVE_BOOT) $$(CONFIG_MSNDPIN_INIT_FILE)))'; \
	    echo 'FILES_BOOT_UP_TO_DATE += $@'; \
	    echo 'endif' \
	) > .$@.boot
endif



# PSS (ECHO-ADI2111)

pss.o: pss_boot.h

ifeq ($(CONFIG_PSS_HAVE_BOOT),y)
    pss_boot.h: $(patsubst "%", %, $(CONFIG_PSS_BOOT_FILE)) bin2hex
	./bin2hex pss_synth < $(CONFIG_PSS_BOOT_FILE) > $@
else
    pss_boot.h:
	(							\
	    echo 'static unsigned char * pss_synth = NULL;';	\
	    echo 'static int pss_synthLen = 0;';		\
	) > $@
endif
	@ ( \
	    echo 'ifeq ($(strip $(CONFIG_PSS_HAVE_BOOT) $(CONFIG_PSS_BOOT_FILE)),$$(strip $$(CONFIG_PSS_HAVE_BOOT) $$(CONFIG_PSS_BOOT_FILE)))'; \
	    echo 'FILES_BOOT_UP_TO_DATE += $@'; \
	    echo 'endif' \
	) > .$@.boot



# MediaTrix AudioTrix Pro

trix.o: trix_boot.h

ifeq ($(CONFIG_TRIX_HAVE_BOOT),y)
    trix_boot.h: $(patsubst "%", %, $(CONFIG_TRIX_BOOT_FILE)) hex2hex
	./hex2hex -i trix_boot < $(CONFIG_TRIX_BOOT_FILE) > $@
else
    trix_boot.h:
	(							\
	    echo 'static unsigned char * trix_boot = NULL;';	\
	    echo 'static int trix_boot_len = 0;';		\
	) > $@
endif
	@ ( \
	    echo 'ifeq ($(strip $(CONFIG_TRIX_HAVE_BOOT) $(CONFIG_TRIX_BOOT_FILE)),$$(strip $$(CONFIG_TRIX_HAVE_BOOT) $$(CONFIG_TRIX_BOOT_FILE)))'; \
	    echo 'FILES_BOOT_UP_TO_DATE += $@'; \
	    echo 'endif' \
	) > .$@.boot



# Find boot files whose source file names have changed and force rebuild.

FILES_BOOT_UP_TO_DATE :=

FILES_BOOT_EXIST := $(wildcard .*.boot)
ifneq ($(FILES_BOOT_EXIST),)
include $(FILES_BOOT_EXIST)
endif

FILES_BOOT_CHANGED := $(strip \
    $(filter-out $(FILES_BOOT_UP_TO_DATE), \
	maui_boot.h pss_boot.h trix_boot.h))

ifneq ($(FILES_BOOT_CHANGED),)
$(FILES_BOOT_CHANGED): dummy
endif

=== linux/drivers/video/Makefile ===
# Makefile for the Linux video drivers.
# 5 Aug 1999, James Simmons, <mailto:jsimmons@edgeglobal.com>
# Rewritten to use lists instead of if-statements.

O_TARGET := video.o

mod-subdirs	:= matrox sti

# All of the (potential) objects that export symbols.
# This list comes from 'grep -l EXPORT_SYMBOL *.[hc]'.

export-objs    := fbmem.o fbcmap.o fbcon.o fbmon.o modedb.o \
		  fbcon-afb.o fbcon-ilbm.o \
		  fbcon-vga.o fbcon-iplan2p2.o fbcon-iplan2p4.o \
		  fbcon-iplan2p8.o fbcon-vga-planes.o fbcon-cfb16.o \
		  fbcon-cfb2.o fbcon-cfb24.o fbcon-cfb32.o fbcon-cfb4.o \
		  fbcon-cfb8.o fbcon-mac.o fbcon-mfb.o \
		  cyber2000fb.o sa1100fb.o fbcon-hga.o

# Each configuration option enables a list of files.

obj-$(CONFIG_DUMMY_CONSOLE)       += dummycon.o
obj-$(CONFIG_SGI_NEWPORT_CONSOLE) += newport_con.o
obj-$(CONFIG_PROM_CONSOLE)        += promcon.o promcon_tbl.o
obj-$(CONFIG_VGA_CONSOLE)         += vgacon.o
obj-$(CONFIG_MDA_CONSOLE)         += mdacon.o

obj-$(CONFIG_FONT_SUN8x16)        += font_sun8x16.o
obj-$(CONFIG_FONT_SUN12x22)       += font_sun12x22.o
obj-$(CONFIG_FONT_8x8)            += font_8x8.o
obj-$(CONFIG_FONT_8x16)           += font_8x16.o
obj-$(CONFIG_FONT_6x11)           += font_6x11.o
obj-$(CONFIG_FONT_PEARL_8x8)      += font_pearl_8x8.o
obj-$(CONFIG_FONT_ACORN_8x8)      += font_acorn_8x8.o

# Add fbmon.o back into obj-$(CONFIG_FB) in 2.5.x
obj-$(CONFIG_FB)                  += fbmem.o fbcmap.o modedb.o fbcon.o fonts.o
# Only include macmodes.o if we have FB support and are PPC
ifeq ($(CONFIG_FB),y)
obj-$(CONFIG_PPC)                 += macmodes.o
endif

obj-$(CONFIG_FB_ACORN)            += acornfb.o
obj-$(CONFIG_FB_AMIGA)            += amifb.o
obj-$(CONFIG_FB_PM2)              += pm2fb.o fbgen.o
obj-$(CONFIG_FB_APOLLO)           += dnfb.o
obj-$(CONFIG_FB_Q40)              += q40fb.o
obj-$(CONFIG_FB_ATARI)            += atafb.o
obj-$(CONFIG_FB_ATY128)           += aty128fb.o
obj-$(CONFIG_FB_RADEON)		  += radeonfb.o
obj-$(CONFIG_FB_IGA)              += igafb.o
obj-$(CONFIG_FB_CONTROL)          += controlfb.o
obj-$(CONFIG_FB_PLATINUM)         += platinumfb.o
obj-$(CONFIG_FB_VALKYRIE)         += valkyriefb.o
obj-$(CONFIG_FB_CT65550)          += chipsfb.o
obj-$(CONFIG_FB_CYBER)            += cyberfb.o
obj-$(CONFIG_FB_CYBER2000)        += cyber2000fb.o
obj-$(CONFIG_FB_SGIVW)            += sgivwfb.o
obj-$(CONFIG_FB_3DFX)             += tdfxfb.o
obj-$(CONFIG_FB_MAC)              += macfb.o macmodes.o
obj-$(CONFIG_FB_HP300)            += hpfb.o
obj-$(CONFIG_FB_OF)               += offb.o
obj-$(CONFIG_FB_IMSTT)            += imsttfb.o
obj-$(CONFIG_FB_RETINAZ3)         += retz3fb.o
obj-$(CONFIG_FB_CLGEN)            += clgenfb.o fbgen.o
obj-$(CONFIG_FB_TRIDENT)          += tridentfb.o fbgen.o
obj-$(CONFIG_FB_S3TRIO)           += S3triofb.o
obj-$(CONFIG_FB_TGA)              += tgafb.o fbgen.o
obj-$(CONFIG_FB_VESA)             += vesafb.o 
obj-$(CONFIG_FB_VGA16)            += vga16fb.o fbcon-vga-planes.o
obj-$(CONFIG_FB_VIRGE)            += virgefb.o
obj-$(CONFIG_FB_G364)             += g364fb.o
obj-$(CONFIG_FB_FM2)              += fm2fb.o
obj-$(CONFIG_FB_CREATOR)          += creatorfb.o sbusfb.o
obj-$(CONFIG_FB_CGSIX)            += cgsixfb.o sbusfb.o
obj-$(CONFIG_FB_BWTWO)            += bwtwofb.o sbusfb.o
obj-$(CONFIG_FB_CGTHREE)          += cgthreefb.o sbusfb.o
obj-$(CONFIG_FB_TCX)              += tcxfb.o sbusfb.o
obj-$(CONFIG_FB_CGFOURTEEN)       += cgfourteenfb.o sbusfb.o
obj-$(CONFIG_FB_P9100)            += p9100fb.o sbusfb.o
obj-$(CONFIG_FB_LEO)              += leofb.o sbusfb.o
obj-$(CONFIG_FB_PMAG_BA)          += pmag-ba-fb.o
obj-$(CONFIG_FB_PMAGB_B)          += pmagb-b-fb.o
obj-$(CONFIG_FB_MAXINE)           += maxinefb.o
obj-$(CONFIG_FB_TX3912)           += tx3912fb.o

subdir-$(CONFIG_STI_CONSOLE)      += sti
ifeq ($(CONFIG_STI_CONSOLE),y)
obj-y                             += sti/sti.o fonts.o
endif

subdir-$(CONFIG_FB_STI)           += sti
ifeq ($(CONFIG_FB_STI),y)
obj-y                             += sti/sti.o fbgen.o
endif


subdir-$(CONFIG_FB_MATROX)	  += matrox
ifeq ($(CONFIG_FB_MATROX),y)
obj-y				  += matrox/matrox.o
endif

subdir-$(CONFIG_FB_RIVA)	  += riva
ifeq ($(CONFIG_FB_RIVA),y)
obj-y				  += riva/rivafb.o
endif

subdir-$(CONFIG_FB_SIS)		  += sis
ifeq ($(CONFIG_FB_SIS),y)
obj-y				  += sis/sisfb.o
endif

subdir-$(CONFIG_FB_ATY)		  += aty
ifeq ($(CONFIG_FB_ATY),y)
obj-y				  += aty/atyfb.o
endif

obj-$(CONFIG_FB_SUN3)             += sun3fb.o
obj-$(CONFIG_FB_BWTWO)            += bwtwofb.o
obj-$(CONFIG_FB_HGA)              += hgafb.o  
obj-$(CONFIG_FB_SA1100)           += sa1100fb.o
obj-$(CONFIG_FB_VIRTUAL)          += vfb.o  
obj-$(CONFIG_FB_HIT)              += hitfb.o fbgen.o
obj-$(CONFIG_FB_E1355)            += epson1355fb.o fbgen.o
obj-$(CONFIG_FB_PVR2)             += pvr2fb.o
obj-$(CONFIG_FB_VOODOO1)          += sstfb.o

# Generic Low Level Drivers

obj-$(CONFIG_FBCON_AFB)           += fbcon-afb.o
obj-$(CONFIG_FBCON_CFB2)          += fbcon-cfb2.o
obj-$(CONFIG_FBCON_CFB4)          += fbcon-cfb4.o
obj-$(CONFIG_FBCON_CFB8)          += fbcon-cfb8.o
obj-$(CONFIG_FBCON_CFB16)         += fbcon-cfb16.o
obj-$(CONFIG_FBCON_CFB24)         += fbcon-cfb24.o
obj-$(CONFIG_FBCON_CFB32)         += fbcon-cfb32.o
obj-$(CONFIG_FBCON_ILBM)          += fbcon-ilbm.o
obj-$(CONFIG_FBCON_IPLAN2P2)      += fbcon-iplan2p2.o
obj-$(CONFIG_FBCON_IPLAN2P4)      += fbcon-iplan2p4.o
obj-$(CONFIG_FBCON_IPLAN2P8)      += fbcon-iplan2p8.o
obj-$(CONFIG_FBCON_IPLAN2P16)     += fbcon-iplan2p16.o
obj-$(CONFIG_FBCON_MAC)           += fbcon-mac.o
obj-$(CONFIG_FBCON_MFB)           += fbcon-mfb.o
obj-$(CONFIG_FBCON_VGA)           += fbcon-vga.o
obj-$(CONFIG_FBCON_HGA)           += fbcon-hga.o
obj-$(CONFIG_FBCON_STI)           += fbcon-sti.o

include $(TOPDIR)/Rules.make

clean:
	rm -f core *.o *.a *.s

../conmakehash: ../conmakehash.c
	$(HOSTCC) $(HOSTCFLAGS) -o ../conmakehash ../conmakehash.c

promcon_tbl.c: prom.uni ../char/conmakehash
	../char/conmakehash prom.uni | \
	sed -e '/#include <[^>]*>/p' -e 's/types/init/' \
	    -e 's/dfont\(_uni.*\]\)/promfont\1 __initdata/' > promcon_tbl.c

promcon_tbl.o: promcon_tbl.c $(TOPDIR)/include/linux/types.h

=== linux/fs/nls/Makefile ===
#
# Makefile for native language support
#

obj-y	:=	nls_base.o
obj-m	:=
obj-n	:=
obj-	:=

obj-$(CONFIG_NLS_CODEPAGE_437)	+= nls_cp437.o
obj-$(CONFIG_NLS_CODEPAGE_737)	+= nls_cp737.o
obj-$(CONFIG_NLS_CODEPAGE_775)	+= nls_cp775.o
obj-$(CONFIG_NLS_CODEPAGE_850)	+= nls_cp850.o
obj-$(CONFIG_NLS_CODEPAGE_852)	+= nls_cp852.o
obj-$(CONFIG_NLS_CODEPAGE_855)	+= nls_cp855.o
obj-$(CONFIG_NLS_CODEPAGE_857)	+= nls_cp857.o
obj-$(CONFIG_NLS_CODEPAGE_860)	+= nls_cp860.o
obj-$(CONFIG_NLS_CODEPAGE_861)	+= nls_cp861.o
obj-$(CONFIG_NLS_CODEPAGE_862)	+= nls_cp862.o
obj-$(CONFIG_NLS_CODEPAGE_863)	+= nls_cp863.o
obj-$(CONFIG_NLS_CODEPAGE_864)	+= nls_cp864.o
obj-$(CONFIG_NLS_CODEPAGE_865)	+= nls_cp865.o
obj-$(CONFIG_NLS_CODEPAGE_866)	+= nls_cp866.o
obj-$(CONFIG_NLS_CODEPAGE_869)	+= nls_cp869.o
obj-$(CONFIG_NLS_CODEPAGE_874)	+= nls_cp874.o nls_tis-620.o
obj-$(CONFIG_NLS_CODEPAGE_932)	+= nls_cp932.o nls_sjis.o nls_euc-jp.o
obj-$(CONFIG_NLS_CODEPAGE_936)	+= nls_cp936.o nls_gb2312.o
obj-$(CONFIG_NLS_CODEPAGE_949)	+= nls_cp949.o nls_euc-kr.o
obj-$(CONFIG_NLS_CODEPAGE_950)	+= nls_cp950.o nls_big5.o
obj-$(CONFIG_NLS_CODEPAGE_1250)	+= nls_cp1250.o
obj-$(CONFIG_NLS_CODEPAGE_1251)	+= nls_cp1251.o
obj-$(CONFIG_NLS_CODEPAGE_1252)	+= nls_cp1252.o
obj-$(CONFIG_NLS_CODEPAGE_1253)	+= nls_cp1253.o
obj-$(CONFIG_NLS_CODEPAGE_1254)	+= nls_cp1254.o
obj-$(CONFIG_NLS_CODEPAGE_1256)	+= nls_cp1256.o
obj-$(CONFIG_NLS_CODEPAGE_1257)	+= nls_cp1257.o
obj-$(CONFIG_NLS_CODEPAGE_1258)	+= nls_cp1258.o
obj-$(CONFIG_NLS_ISO8859_1)	+= nls_iso8859-1.o
obj-$(CONFIG_NLS_ISO8859_2)	+= nls_iso8859-2.o
obj-$(CONFIG_NLS_ISO8859_3)	+= nls_iso8859-3.o
obj-$(CONFIG_NLS_ISO8859_4)	+= nls_iso8859-4.o
obj-$(CONFIG_NLS_ISO8859_5)	+= nls_iso8859-5.o
obj-$(CONFIG_NLS_ISO8859_6)	+= nls_iso8859-6.o
obj-$(CONFIG_NLS_ISO8859_7)	+= nls_iso8859-7.o
obj-$(CONFIG_NLS_ISO8859_8)	+= nls_cp1255.o nls_iso8859-8.o
obj-$(CONFIG_NLS_ISO8859_9)	+= nls_iso8859-9.o
obj-$(CONFIG_NLS_ISO8859_10)	+= nls_iso8859-10.o
obj-$(CONFIG_NLS_ISO8859_13)	+= nls_iso8859-13.o
obj-$(CONFIG_NLS_ISO8859_14)	+= nls_iso8859-14.o
obj-$(CONFIG_NLS_ISO8859_15)	+= nls_iso8859-15.o
obj-$(CONFIG_NLS_KOI8_R)	+= nls_koi8-r.o
obj-$(CONFIG_NLS_KOI8_U)	+= nls_koi8-u.o nls_koi8-ru.o
obj-$(CONFIG_NLS_ABC)		+= nls_abc.o
obj-$(CONFIG_NLS_UTF8)		+= nls_utf8.o

export-objs = $(obj-y)

O_TARGET = nls.o

include $(TOPDIR)/Rules.make

=== linux/arch/ia64/lib/Makefile ===
#
# Makefile for ia64-specific library routines..
#

.S.o:
	$(CC) $(AFLAGS) $(AFLAGS_KERNEL) -c $< -o $@

L_TARGET = lib.a

export-objs := io.o swiotlb.o

obj-y := __divsi3.o __udivsi3.o __modsi3.o __umodsi3.o					\
	__divdi3.o __udivdi3.o __moddi3.o __umoddi3.o					\
	checksum.o clear_page.o csum_partial_copy.o copy_page.o				\
	copy_user.o clear_user.o strncpy_from_user.o strlen_user.o strnlen_user.o	\
	flush.o io.o do_csum.o								\
	memcpy.o memset.o strlen.o swiotlb.o

IGNORE_FLAGS_OBJS =	__divsi3.o __udivsi3.o __modsi3.o __umodsi3.o \
			__divdi3.o __udivdi3.o __moddi3.o __umoddi3.o

$(L_TARGET): $(obj-y) $(export-objs)

__divdi3.o: idiv64.S
	$(CC) $(AFLAGS) $(AFLAGS_KERNEL) -c -o $@ $<

__udivdi3.o: idiv64.S
	$(CC) $(AFLAGS) $(AFLAGS_KERNEL) -c -DUNSIGNED -c -o $@ $<

__moddi3.o: idiv64.S
	$(CC) $(AFLAGS) $(AFLAGS_KERNEL) -c -DMODULO -c -o $@ $<

__umoddi3.o: idiv64.S
	$(CC) $(AFLAGS) $(AFLAGS_KERNEL) -c -DMODULO -DUNSIGNED -c -o $@ $<

__divsi3.o: idiv32.S
	$(CC) $(AFLAGS) $(AFLAGS_KERNEL) -c -o $@ $<

__udivsi3.o: idiv32.S
	$(CC) $(AFLAGS) $(AFLAGS_KERNEL) -c -DUNSIGNED -c -o $@ $<

__modsi3.o: idiv32.S
	$(CC) $(AFLAGS) $(AFLAGS_KERNEL) -c -DMODULO -c -o $@ $<

__umodsi3.o: idiv32.S
	$(CC) $(AFLAGS) $(AFLAGS_KERNEL) -c -DMODULO -DUNSIGNED -c -o $@ $<

include $(TOPDIR)/Rules.make

=== linux/drivers/char/joystick/Makefile ===
#
# Makefile for the joystick drivers.
#

O_TARGET	:= js.o

# Objects that export symbols.

export-objs	:= serio.o gameport.o

# I-Force may need both USB and RS-232

ifeq ($(CONFIG_INPUT_IFORCE_232),m)
	ifeq ($(CONFIG_INPUT_IFORCE_USB),y)
		CONFIG_INPUT_IFORCE_USB := m
	endif
endif
ifeq ($(CONFIG_INPUT_IFORCE_USB),m)
	ifeq ($(CONFIG_INPUT_IFORCE_232),y)
		CONFIG_INPUT_IFORCE_232 := m
	endif
endif

# Object file lists.

obj-y	:=
obj-m	:=
obj-n	:=
obj-	:=

# Each configuration option enables a list of files.

obj-$(CONFIG_INPUT_GAMEPORT)	+= gameport.o
obj-$(CONFIG_INPUT_SERIO)	+= serio.o

obj-$(CONFIG_INPUT_SERPORT)	+= serport.o

obj-$(CONFIG_INPUT_NS558)	+= ns558.o
obj-$(CONFIG_INPUT_LIGHTNING)	+= lightning.o
obj-$(CONFIG_INPUT_PCIGAME)	+= pcigame.o
obj-$(CONFIG_INPUT_CS461X)	+= cs461x.o
obj-$(CONFIG_INPUT_EMU10K1)	+= emu10k1-gp.o

obj-$(CONFIG_INPUT_WARRIOR)	+= warrior.o
obj-$(CONFIG_INPUT_MAGELLAN)	+= magellan.o
obj-$(CONFIG_INPUT_SPACEORB)	+= spaceorb.o
obj-$(CONFIG_INPUT_SPACEBALL)	+= spaceball.o
obj-$(CONFIG_INPUT_STINGER)	+= stinger.o
obj-$(CONFIG_INPUT_IFORCE_232)	+= iforce.o
obj-$(CONFIG_INPUT_IFORCE_USB)	+= iforce.o

obj-$(CONFIG_INPUT_ANALOG)	+= analog.o
obj-$(CONFIG_INPUT_A3D)		+= a3d.o
obj-$(CONFIG_INPUT_ADI)		+= adi.o
obj-$(CONFIG_INPUT_COBRA)	+= cobra.o
obj-$(CONFIG_INPUT_GF2K)	+= gf2k.o
obj-$(CONFIG_INPUT_GRIP)	+= grip.o
obj-$(CONFIG_INPUT_INTERACT)	+= interact.o
obj-$(CONFIG_INPUT_TMDC)	+= tmdc.o
obj-$(CONFIG_INPUT_SIDEWINDER)	+= sidewinder.o

obj-$(CONFIG_INPUT_DB9)		+= db9.o
obj-$(CONFIG_INPUT_GAMECON)	+= gamecon.o
obj-$(CONFIG_INPUT_TURBOGRAFX)	+= turbografx.o

obj-$(CONFIG_INPUT_AMIJOY)	+= amijoy.o

# The global Rules.make.

include $(TOPDIR)/Rules.make

=== linux/drivers/net/irda/Makefile ===
# File: drivers/irda/Makefile
#
# Makefile for the Linux IrDA infrared port device drivers.
#
# 9 Aug 2000, Christoph Hellwig <hch@infradead.org>
# Rewritten to use lists instead of if-statements.
#

O_TARGET := irda.o

export-objs	= irport.o


obj-$(CONFIG_IRTTY_SIR)		+= irtty.o
obj-$(CONFIG_IRPORT_SIR)	+= 		irport.o
obj-$(CONFIG_USB_IRDA)		+= irda-usb.o
obj-$(CONFIG_NSC_FIR)		+= nsc-ircc.o
obj-$(CONFIG_WINBOND_FIR)	+= w83977af_ir.o
obj-$(CONFIG_SA1100_FIR)	+= sa1100_ir.o
obj-$(CONFIG_TOSHIBA_FIR)	+= toshoboe.o
obj-$(CONFIG_SMC_IRCC_FIR)	+= smc-ircc.o	irport.o
obj-$(CONFIG_ALI_FIR)		+= ali-ircc.o
obj-$(CONFIG_VLSI_FIR)		+= vlsi_ir.o
obj-$(CONFIG_ESI_DONGLE)	+= esi.o
obj-$(CONFIG_TEKRAM_DONGLE)	+= tekram.o
obj-$(CONFIG_ACTISYS_DONGLE)	+= actisys.o
obj-$(CONFIG_GIRBIL_DONGLE)	+= girbil.o
obj-$(CONFIG_LITELINK_DONGLE)	+= litelink.o
obj-$(CONFIG_OLD_BELKIN_DONGLE)	+= old_belkin.o
obj-$(CONFIG_EP7211_IR)		+= ep7211_ir.o

include $(TOPDIR)/Rules.make

=== debian/changelog ===
kernel-image-2.4.18-hppa (62.4) oldstable-security; urgency=high

  * Non-maintainer upload by the Security Team
  * Fix lcall DoS [arch/i386/kernel/entry.S, CVE-2002-0429]
  * Disabled O_DIRECT (CAN-2003-0018):
    . fs/fcntl.c
    . fs/open.c
  * Applied ptrace bugfix by Alan Cox to fix local root exploit
    [http://archives.neohapsis.com/archives/vulnwatch/2003-q1/0134.html,
    CAN-2003-0127]
  * Fixed hashing exploits in network stack (David S. Miller).
    Patch extracted from kernel-source-2.4.18 (CAN-2003-0244)
  * Fixed TIOCCONS and writing to /dev/console (CVE-2003-0247):
   . drivers/char/tty_io.c
   . include/linux/tty.h
  * Fixed hashing exploits in fragment processing (2.4.21rc7).
    (CVE-2003-0364)
  * Made /proc/tty/driver root-only (CAN-2003-0461):
    . include/linux/proc_fs.h
    . fs/proc/generic.c
    . fs/proc/proc_tty.c
  * Fix race condition in execve env_start/env_end initialization.
    (CVE-2003-0462)
    . fs/proc/base.c
  * Fixed ptrace/proc bug in fs/proc/base.c (CAN-2003-0501).
  * Applied patch from John Byrne <john.l.byrne@hp.com> for Linux 2.4.26
    to fix local denial of service in do_fork()
    <http://marc.theaimsgroup.com/?l=linux-kernel&m=108139073506983&w=2>
    [kernel/fork.c, CAN-2004-0427]
  * Applied patch by Marcelo Tosatti <marcelo.tosatti@cyclades.com> to fix
    potential memory access to free memory in /proc handling
    [fs/proc/base.c, CAN-2005-0489]
  * Applied patch by Marcelo Tosatti <marcelo.tosatti@cyclades.com> to fix
    a possible buffer overflow in panic() [kernel/panic.c, CAN-2004-0394]
  * Applied patch by David Mosberger <davidm@napali.hpl.hp.com> to fix
    local denial of service in combination with gdb 6.x and NPTL on IA-64
    <http://marc.theaimsgroup.com/?l=linux-ia64&m=108026377907667&w=2>
    [arch/ia64/kernel/unwind.c, CAN-2004-0447]
  * Applied patch by Alexander Nyberg and Andi/Sergey to fix local denial
    of service.  <http://linuxreviews.org/news/2004-06-11_kernel_crash/>
    [include/asm-i386/i387.h, CAN-2004-0554]
  * Applied patch by Arun Sharma <arun.sharma@intel.com> to fix register
    information leak on the IA64 architecture
    <http://lia64.bkbits.net:8080/to-linus-2.5/cset@1.1726.29.7>
    [include/asm-ia64/system.h, CAN-2004-0565]
  * Backported patch by Mark Cox to fix information leak by initialising
    allocated data structures [drivers/usb/serial/io_edgeport.c,
    drivers/sound/audio.c, drivers/usb/vicam.c, CAN-2004-0685]
    <http://linux.bkbits.net:8080/linux-2.4/cset@410582380U3H9KOx8J2YZmMT0bhXQw>
  * Applied patch from Marcelo Tosatti to fix i386 SMP page fault handler
    privilege escalation [include/linux/mm.h, CAN-2005-0001]
  * Applied patch by Stefan Esser to fix missing boundary checks
    [fs/smbfs/proc.c, fs/smbfs/sock.c, CAN-2004-0883]
  * Applied patch by Stefan Esser to fix information leak
    [fs/smbfs/sock.c, CAN-2004-0949]
  * Applied patch by Herbert Xu to fix a denial of service in scm_send()
    <http://linux.bkbits.net:8080/linux-2.4/cset@41b76e94BsJKm8jhVtyDat9ZM1dXXg>,
    added patch by Marcus Meissner to fix more 64/32 bit compatibility
    code, added additional patch by Olaf Kirch and Marcus Meissner for
    type correction [arch/ia64/ia32/sys_ia32.c,
    arch/s390x/kernel/linux32.c, include/linux/socket.h, net/core/scm.c,
    net/ipv4/ip_sockglue.c, net/ipv6/datagram.c, CAN-2004-1016]
  * Applied patch by Thiemo Seufer to fix local ptrace root in the MIPS
    ptrace implementation [arch/mips/kernel/scall_o32.S,
    arch/mips/tools/offset.c, arch/mips64/kernel/scall_64.S,
    arch/mips64/kernel/scall_o32.S, CAN-2004-0997]
  * Applied patch by Marcelo Tosatti to fix integer overflow in the
    vc_resize() function [drivers/char/console.c, CAN-2004-1333]
  * Applied patch by Dave Miller to fix memory leak in ip_options_get()
    [net/ipv4/ip_options.c, CAN-2004-1335]
  * Applied patch by Greg Kroah-Hartman to fix buffer overflow and crash
    [drivers/usb/serial/io_edgeport.c, CAN-2004-1017]
  * Applied patch by Jan Harkes to fix to add bounds checking for tainted
    scalars [include/linux/coda.h, fs/coda/upcall.c, CAN-2005-0124]
  * Applied patch by Andrea Arcangeli from 2.4.24 to fix privilege
    escalation in the mremap() syscall [mm/mremap.c, CAN-2005-0528]
  * Applied patch by Tom Rini to fix information leak
    [drivers/char/efirtc.c, drivers/char/rtc.c, drivers/macintosh/rtc.c,
    drivers/sbus/char/rtc.c, CAN-2003-0984]
  * Applied patch by Chris Wright to fix wrong return value check while
    filling kernel buffers [fs/binfmt_elf.c, CAN-2004-1070]
  * Applied patch by Chris Wright to fix incorrect error behaviour when
    mmap() fails [fs/binfmt_elf.c, CAN-2004-1071]
  * Applied patch by Chris Wright to fix NULL termination vulnerability
    when reading an interpreter [fs/binfmt_elf.c, CAN-2004-1072]
  * Applied patch by Chris Wright to fix reading of non-readable ELF
    binaries [fs/binfmt_elf.c, CAN-2004-1073]
  * Applied patch by Chris Wright to not insert overlapping regions in
    setup_arg_pages() [fs/exec.c, associated to CAN-2004-1074]
  * Applied patch by Chris Wright to fix error handling in do_brk() when
    setting up bss in a.out [fs/binfmt_aout.c, CAN-2004-1074]
  * Applied patch by Chris Wright to denial of service in the ELF loader
    when the interpreter architecture doesn't match the current one
    <http://linux.bkbits.net:8080/linux-2.4/cset@4021346f79nBb-4X_usRikR3Iyb4Vg>
    [fs/binfmt_elf.c, CAN-2004-0138]
  * Applied patch by Dave Miller to serialize dgram read using semaphore
    [net/unix/af_unix.c, CAN-2004-1068]
  * Applied patch by Chris Wright to fix denial of service in the ELF loader
    <http://linux.bkbits.net:8080/linux-2.4/cset@4076466d_SqUm4azg4_v3FIG2-X6XQ>
    [fs/binfmt_elf.c, CAN-2004-1234]
  * Backported patch by Nanhai Zou from 2.6 to fix denial of service via
    broken executables [arch/ia64/ia32/binfmt_elf32.c,
    arch/ia64/mm/init.c, fs/exec.c, include/linux/mm.h, mm/mmap.c,
    CAN-2005-0003]


=== debian/control ===
Source: kernel-image-2.4.18-hppa
Section: base
Priority: optional
Maintainer:  Bdale Garbee <bdale@gag.com>
Standards-Version: 3.5.6.0
Build-Depends: debhelper, modutils, kernel-package (>= 7.37), bzip2, gcc-3.0

Package: kernel-source-2.4.18-hppa
Architecture: all
Section: devel
Priority: optional
Provides: kernel-source, kernel-source-2.4
Depends: binutils, fileutils (>= 4.0)
Recommends: libc-dev, gcc, make
Suggests: libncurses-dev | ncurses-dev, task-tcltk-dev, kernel-package
Description: Linux kernel source for version 2.4.18 on HPPA
 This package provides the source code for the Linux kernel version
 2.4.18 for HPPA processors.
 .
 If you wish to use this package to create a custom Linux kernel, then
 it is suggested that you investigate the package kernel-package,
 which has been designed to ease the task of creating kernel image
 packages.

Package: kernel-headers-2.4.18-hppa
Architecture: hppa
Section: devel
Priority: optional
Depends: fileutils (>= 4.0)
Provides: kernel-headers, kernel-headers-2.4
Description: Header files related to Linux kernel version 2.4.18 on HPPA
 This package provides kernel header files for version 2.4.18 on HPPA, for 
 sites that want the latest kernel headers. Please read
 /usr/share/doc/kernel-headers-2.4.18-hppa/debian.README.gz for details

Package: kernel-image-2.4.18-32
Architecture: hppa
Section: base
Priority: optional
Provides: kernel-image,  kernel-image-2.4
Depends: initrd-tools (>= 0.1.6), fileutils (>= 4.0), modutils (>= 2.3.12)
Suggests: palo
Description: 32 bit Linux kernel image for version 2.4.18 on HPPA.
 This package contains the 32 bit Linux kernel image for version 2.4.18
 on HPPA, the corresponding System.map file, and the modules built by
 the packager.  It also contains scripts that try to ensure that the
 system is not left in a unbootable state after an update.
 .
 Kernel image packages are generally produced using kernel-package,
 and it is suggested that you install that package if you wish to
 create a custom kernel.

Package: kernel-image-2.4.18-64
Architecture: hppa
Section: base
Priority: optional
Provides: kernel-image,  kernel-image-2.4
Depends: initrd-tools (>= 0.1.6), fileutils (>= 4.0), modutils (>= 2.3.12)
Suggests: palo
Description: 64 bit Linux kernel image for version 2.4.18 on HPPA.
 This package contains the 64 bit Linux kernel image for version 2.4.18
 on HPPA, the corresponding System.map file, and the modules built by
 the packager.  It also contains scripts that try to ensure that the
 system is not left in a unbootable state after an update.
 .
 Kernel image packages are generally produced using kernel-package,
 and it is suggested that you install that package if you wish to
 create a custom kernel.

Package: kernel-image-2.4.18-32-smp
Architecture: hppa
Section: base
Priority: optional
Provides: kernel-image,  kernel-image-2.4
Depends: initrd-tools (>= 0.1.6), fileutils (>= 4.0), modutils (>= 2.3.12)
Suggests: palo
Description: 32 bit SMP Linux kernel image for version 2.4.18 on HPPA.
 This package contains the 32 bit SMP Linux kernel image for version
 2.4.18 on HPPA, the corresponding System.map file, and the modules built
 by the packager.  It also contains scripts that try to ensure that the
 system is not left in a unbootable state after an update.
 .
 Kernel image packages are generally produced using kernel-package,
 and it is suggested that you install that package if you wish to
 create a custom kernel.

Package: kernel-image-2.4.18-64-smp
Architecture: hppa
Section: base
Priority: optional
Provides: kernel-image,  kernel-image-2.4
Depends: initrd-tools (>= 0.1.6), fileutils (>= 4.0), modutils (>= 2.3.12)
Suggests: palo
Description: 64 bit SMP Linux kernel image for version 2.4.18 on HPPA.
 This package contains the 64 bit SMP Linux kernel image for version
 2.4.18 on HPPA, the corresponding System.map file, and the modules built
 by the packager.  It also contains scripts that try to ensure that the
 system is not left in a unbootable state after an update.
 .
 Kernel image packages are generally produced using kernel-package,
 and it is suggested that you install that package if you wish to
 create a custom kernel.

=== debian/rules ===
#!/usr/bin/make -f
#
# debian/rules for kernel-image-*-hppa
#
# GNU copyright 1997 to 1999 by Joey Hess.
# Copyright (c) 1999-2001 Herbert Xu <herbert@debian.org>
# Copyright (c) 2001 Richard Hirst <rhirst@linuxcare.com>
#

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=2

SHELL := sh -e

configdir := linux/arch/parisc/debian-configs

export version := $(shell \
	head -1 debian/changelog | \
	sed 's/^kernel-image-\(.*\)-hppa.*$$/\1/' \
)
fullversion := $(shell \
	dpkg-parsechangelog | sed -n 's/^Version: //p; t e; b; :e; q' \
)
flavours := $(shell \
	if ( command -v hppa64-linux-gcc > /dev/null 2>&1 ); \
	then \
		find $(configdir) -maxdepth 1 \( -type f -o -type l \) -a -printf '%f\n'; \
	else \
		echo -e "\n\nWARNING: ============================================================" >&2; \
		echo "  Cannot build 64 bit kernel images as the 32 to 64 bit hppa cross-compiler" >&2; \
		echo "  is not installed.  If the official package is not yet available, an" >&2; \
		echo "  unofficial one may be found at" >&2; \
		echo "  <http://ftp.parisc-linux.org/unofficial-debs/>" >&2; \
		echo -e "WARNING: ================================================================\n\n" >&2; \
		find $(configdir) -maxdepth 1 \( -type f -o -type l \) -a ! -name '64*' -printf '%f\n'; \
	fi \
)

cvs-update:
	( cd linux; \
	rm -f Makefile ; \
	cvs -z3 -d :pserver:anonymous@cvs.parisc-linux.org:/var/cvs up -d . ; \
	grep ^EXTRAVERSION Makefile > ../linux-EXTRAVERSION; \
	mv -f Makefile Makefile.tmp; \
	sed 's/^EXTRAVERSION.*/EXTRAVERSION =/' < Makefile.tmp > Makefile; \
	rm -f Makefile.tmp; \
	)

unpack: stamp-unpack
stamp-unpack:
	# add Debian packaging goo
	mkdir linux/debian
	cp debian/changelog linux/debian
	cp debian/control linux/debian
	> linux/debian/official

	# copy the source tree for each image flavor, fold in config file
	for i in $(flavours); do \
		cp -al linux build-$$i; \
		cp $(configdir)/$$i build-$$i/.config; \
		cd build-$$i; \
		cd ..; \
	done

	touch stamp-unpack

build: stamp-build
stamp-build: stamp-unpack

	# little to do here... the real work is done in binary-arch target
	
	touch stamp-build

clean:
	rm -rf linux/debian build-* stamp-* *.deb
	( cd linux; make distclean )
	dh_clean

# Build architecture-independent files here.
binary-indep:
	
	# create kernel-headers and kernel-source packages

	cp $(configdir)/32 linux/.config
	cd linux; \
		make-kpkg --append-to-version=-hppa kernel-headers
	cd linux; \
		make-kpkg --append-to-version=-hppa kernel-source
	cat linux/debian/files >> debian/files

	mv *.deb ..


# Build architecture-dependent files here.
binary-arch: stamp-build

	# create kernel-image packages.

	for i in $(flavours); do \
		cd build-$$i; \
		make-kpkg --append-to-version=-$$i kernel_image; \
		cd ..; \
		cat build-$$i/debian/files >> debian/files; \
	done

	mv *.deb ..

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary unpack
